Imports Microsoft.VisualBasic
Imports System
Imports System.Drawing
Imports System.Collections
Imports System.ComponentModel
Imports System.IO
Imports System.Windows.Forms
Imports System.Data

Imports Phoenix.Tools
Imports Phoenix



Namespace Phoenix.Tools.Backup
	Public Class BackupWizard : Inherits System.Windows.Forms.Form
		Private Enum PageIndex
			WelcomPage = 0
			SelectPage = 1
			SourcePage = 2
			DestinationPage = 3
			FinalPage = 4
		End Enum

		#Region "Form Data"
		Private WithEvents wizardForm As WizardForm
		Private welcomePage As WelcomePage
		Private selectPage As SelectPage
		Private databasePage As Phoenix.Tools.Backup.DatabasePage
		Private filePage As FilePage
		Private finalPage As FinalPage
		Private databaseDefaultPage As Phoenix.Tools.Backup.DatabaseDefaultPage

		''' <summary>
		''' Required designer variable.
		''' </summary>
		Private components As System.ComponentModel.Container = Nothing
		#End Region

		#Region "Contructors/Finalizers"
		Public Sub New()
			'
			' Required for Windows Form Designer support
			'
			InitializeComponent()

			wizardForm.WizardButtons = WizardForm.TWizardsButtons.AllShort
		End Sub

		''' <summary>
		''' Clean up any resources being used.
		''' </summary>
		Protected Overrides Overloads Sub Dispose(ByVal disposing As Boolean)
			If disposing Then
				If Not components Is Nothing Then
					components.Dispose()
				End If
			End If
			MyBase.Dispose(disposing)
		End Sub
		#End Region

		#Region "Windows Form Designer generated code"
		''' <summary>
		''' Required method for Designer support - do not modify
		''' the contents of this method with the code editor.
		''' </summary>
		Private Sub InitializeComponent()
            Dim resources As System.Resources.ResourceManager = New System.Resources.ResourceManager(GetType(BackupWizard))
            Me.wizardForm = New Phoenix.Tools.WizardForm
            Me.welcomePage = New Phoenix.Tools.Backup.WelcomePage
            Me.selectPage = New Phoenix.Tools.Backup.SelectPage
            Me.databaseDefaultPage = New Phoenix.Tools.Backup.DatabaseDefaultPage
            Me.databasePage = New Phoenix.Tools.Backup.DatabasePage
            Me.filePage = New Phoenix.Tools.Backup.FilePage
            Me.finalPage = New Phoenix.Tools.Backup.FinalPage
            Me.SuspendLayout()
            '
            'wizardForm
            '
            Me.wizardForm.Dock = System.Windows.Forms.DockStyle.Fill
            Me.wizardForm.Location = New System.Drawing.Point(0, 0)
            Me.wizardForm.Name = "wizardForm"
            Me.wizardForm.PageIndex = 0
            Me.wizardForm.Pages.AddRange(New Phoenix.Tools.WizardPageBase() {Me.welcomePage, Me.selectPage, Me.databaseDefaultPage, Me.databasePage, Me.filePage, Me.finalPage})
            Me.wizardForm.Size = New System.Drawing.Size(498, 358)
            Me.wizardForm.TabIndex = 0
            '
            'welcomePage
            '
            Me.welcomePage.BackColor = System.Drawing.Color.White
            Me.welcomePage.Description = "Backup/Restore utility for Phoenix databasea and configuration files."
            Me.welcomePage.Description2 = "Note: You can restore the Phoenix database over an existing database only."
            Me.welcomePage.Dock = System.Windows.Forms.DockStyle.Fill
            Me.welcomePage.HeaderImage = CType(resources.GetObject("welcomePage.HeaderImage"), System.Drawing.Image)
            Me.welcomePage.ImageList = Nothing
            Me.welcomePage.Index = 0
            Me.welcomePage.Location = New System.Drawing.Point(0, 0)
            Me.welcomePage.Name = "welcomePage"
            Me.welcomePage.Size = New System.Drawing.Size(498, 311)
            Me.welcomePage.TabIndex = 0
            Me.welcomePage.Title = "Welcome to the Backup/Restore Wizard"
            Me.welcomePage.WelcomePage = True
            Me.welcomePage.WizardPageParent = Me.wizardForm
            '
            'selectPage
            '
            Me.selectPage.Description = " You can now backup Phoenix database and configuration settings into a specific f" & _
            "older restore it from the previously made backup file."
            Me.selectPage.Dock = System.Windows.Forms.DockStyle.Fill
            Me.selectPage.HeaderImage = CType(resources.GetObject("selectPage.HeaderImage"), System.Drawing.Image)
            Me.selectPage.ImageList = Nothing
            Me.selectPage.Index = 1
            Me.selectPage.Location = New System.Drawing.Point(0, 0)
            Me.selectPage.Name = "selectPage"
            Me.selectPage.Size = New System.Drawing.Size(715, 635)
            Me.selectPage.TabIndex = 0
            Me.selectPage.Title = "Backup or Restore"
            Me.selectPage.WizardPageParent = Me.wizardForm
            '
            'databaseDefaultPage
            '
            Me.databaseDefaultPage.Description = "Custom database connection settings."
            Me.databaseDefaultPage.Dock = System.Windows.Forms.DockStyle.Fill
            Me.databaseDefaultPage.HeaderImage = CType(resources.GetObject("databaseDefaultPage.HeaderImage"), System.Drawing.Image)
            Me.databaseDefaultPage.ImageList = Nothing
            Me.databaseDefaultPage.Index = 2
            Me.databaseDefaultPage.Location = New System.Drawing.Point(0, 0)
            Me.databaseDefaultPage.Name = "databaseDefaultPage"
            Me.databaseDefaultPage.Size = New System.Drawing.Size(924, 761)
            Me.databaseDefaultPage.TabIndex = 0
            Me.databaseDefaultPage.Title = "Choose a Database"
            Me.databaseDefaultPage.WizardPageParent = Me.wizardForm
            '
            'databasePage
            '
            Me.databasePage.Description = "Specify the Phoenix database that you want to backup or restore from."
            Me.databasePage.Dock = System.Windows.Forms.DockStyle.Fill
            Me.databasePage.HeaderImage = CType(resources.GetObject("databasePage.HeaderImage"), System.Drawing.Image)
            Me.databasePage.ImageList = Nothing
            Me.databasePage.Index = 3
            Me.databasePage.Location = New System.Drawing.Point(0, 0)
            Me.databasePage.Name = "databasePage"
            Me.databasePage.Size = New System.Drawing.Size(924, 761)
            Me.databasePage.TabIndex = 0
            Me.databasePage.Title = "Choose a Database"
            Me.databasePage.WizardPageParent = Me.wizardForm
            '
            'filePage
            '
            Me.filePage.Description = "Specify directory to backup Phoenix database and configuration files or restore f" & _
            "rom it."
            Me.filePage.Dock = System.Windows.Forms.DockStyle.Fill
            Me.filePage.HeaderImage = CType(resources.GetObject("filePage.HeaderImage"), System.Drawing.Image)
            Me.filePage.ImageList = Nothing
            Me.filePage.Index = 4
            Me.filePage.Location = New System.Drawing.Point(0, 0)
            Me.filePage.Name = "filePage"
            Me.filePage.Size = New System.Drawing.Size(715, 635)
            Me.filePage.TabIndex = 0
            Me.filePage.Title = "Choose a backup directory"
            Me.filePage.WizardPageParent = Me.wizardForm
            '
            'finalPage
            '
            Me.finalPage.BackColor = System.Drawing.Color.White
            Me.finalPage.Description = "You have created the following operation settings:"
            Me.finalPage.Dock = System.Windows.Forms.DockStyle.Fill
            Me.finalPage.FinishPage = True
            Me.finalPage.HeaderImage = CType(resources.GetObject("finalPage.HeaderImage"), System.Drawing.Image)
            Me.finalPage.ImageList = Nothing
            Me.finalPage.Index = 5
            Me.finalPage.Location = New System.Drawing.Point(0, 0)
            Me.finalPage.Name = "finalPage"
            Me.finalPage.TabIndex = 0
            Me.finalPage.Title = "Completing the Phoenix Backup\Restore Wizard"
            Me.finalPage.WelcomePage = True
            Me.finalPage.WizardPageParent = Me.wizardForm
            '
            'BackupWizard
            '
            Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
            Me.ClientSize = New System.Drawing.Size(498, 358)
            Me.Controls.Add(Me.wizardForm)
            Me.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedDialog
            Me.Icon = CType(resources.GetObject("$this.Icon"), System.Drawing.Icon)
            Me.KeyPreview = True
            Me.MaximizeBox = False
            Me.MinimizeBox = False
            Me.Name = "BackupWizard"
            Me.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen
            Me.Text = "Phoenix Backup or Restore Wizard"
            Me.ResumeLayout(False)

        End Sub
		#End Region

		#Region "Startup Code"
		''' <summary>
		''' The main entry point for the application.
		''' </summary>
		<STAThread> _
		Shared Sub Main(ByVal args As String())
			Dim om As OperationManager = New OperationManager()
			om.TestPipe()

			If args.Length<>0 Then
				RunConsole(om, args)
			Else
				RunGui(om)
			End If
		End Sub

		Private Shared Sub RunGui(ByVal om As OperationManager)
			Dim bw As BackupWizard = New BackupWizard()
			bw.Manager = om

			Application.Run(bw)
			If bw.Completed Then
			om.ExecuteOperation()
			End If
		End Sub

		Private Shared Sub RunConsole(ByVal om As OperationManager, ByVal args As String())
			For i As Integer = 0 To args.Length - 1
				Try
					Select Case args(i).ToLower()
						Case "/?"
							Usage()
							Return

						Case "/s"
                            i += 1
                            om.DBServer = args(i)

                        Case "/d"
                            i += 1
                            om.DBDatabase = args(i)

                        Case "/u"
                            i += 1
                            om.DBUsername = args(i)
                            om.DBWindowAuthentication = False

                        Case "/p"
                            i += 1
                            om.DBPassword = args(i)

                        Case "/f"
                            i += 1
                            om.BackupDirectory = args(i)
                            om.BackupFile = Path.Combine(om.BackupDirectory, "PhoenixDB.bak")

                        Case "/e"
                            om.DBWindowAuthentication = True

                        Case "/r"
                            om.BackupMode = False

                        Case "/a"
                            om.AttachMode = True
                            om.SetDefaultDatabseSettings()

                        Case "/dbf"
                            i += 1
                            om.BackupFile = args(i)
                    End Select
                Catch
					Usage()
					Return
				End Try
			Next i

			om.ExecuteOperation()
		End Sub

		Private Shared Sub Usage()
			MessageBox.Show("Usage: backupwiz /s sqlserver /d database /f file /u username /p password /e /r", "Help")
		End Sub
		#End Region

		#Region "Form Events"

		Private Sub BackupWizard_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles MyBase.Load
			If (Not manager_Renamed.ShowWelcomePage) Then
				wizardForm.Pages.Remove(welcomePage)
				selectPage.Index = 0
			End If
		End Sub

        Private Sub BackupWizard_Next(ByVal sender As Object, ByVal e As wizardForm.EventNextArgs) Handles wizardForm.NextEvent
            If e.CurrentPage Is selectPage Then
                '				if(manager.BackupMode)
                '				{
                '					databasePage.Index = (int)PageIndex.SourcePage;
                '					filePage.Index = (int)PageIndex.DestinationPage;
                '				}
                '				else
                '				{
                '					databasePage.Index = (int)PageIndex.DestinationPage;
                '					filePage.Index = (int)PageIndex.SourcePage;
                '				}
            End If
        End Sub

#End Region


		Public Property Manager() As OperationManager
			Get
				Return manager_Renamed
			End Get
			Set
				manager_Renamed = Value
				welcomePage.Manager = manager_Renamed
				selectPage.Manager = manager_Renamed
				databaseDefaultPage.Manager = manager_Renamed
				databasePage.Manager = manager_Renamed
				filePage.Manager = manager_Renamed
				finalPage.Manager = manager_Renamed
			End Set
		End Property

		Private manager_Renamed As OperationManager = Nothing
		Private Completed As Boolean = False


		Private Sub wizardForm_PageShown(ByVal sender As Object, ByVal e As Phoenix.Tools.WizardForm.EventNextArgs) Handles wizardForm.PageShown
			e.CurrentPage.OnPageShown()
		End Sub

		Private Sub wizardForm_Finish(ByVal sender As Object, ByVal e As Phoenix.Tools.WizardForm.EventNextArgs) Handles wizardForm.Finish
			Me.Completed = True
			manager_Renamed.SaveUserPreferences()
			Close()
		End Sub

		Private Sub wizardForm_Cancel(ByVal sender As Object, ByVal e As Phoenix.Tools.WizardForm.EventWizardCancelArgs) Handles wizardForm.Cancel
			e.Title = "Conformation"
			e.Message = "Are you sure you want to quit Backup or Restore Wizard?"
		End Sub

		Private Sub wizardForm_WizardClosed(ByVal sender As Object, ByVal e As System.EventArgs) Handles wizardForm.WizardClosed
			Me.Completed = False
			Close()
		End Sub

		Private Sub wizardForm_Back(ByVal sender As Object, ByVal e As WizardForm.EventNextArgs) Handles wizardForm.Back
			If Me.wizardForm.PageIndex = Me.databasePage.Index Then
				Me.wizardForm.MoveBackStep()
			End If
		End Sub
	End Class
End Namespace
