using System;

namespace ComponentGo.Calendars 
{
	/// <summary>
	/// Calendar break.
	/// </summary>
	public class Break
	{
		private System.TimeSpan mBeginBreak;
		private System.TimeSpan mEndBreak;
		private bool mExtra = false;

		/// <summary>
		/// Init.
		/// </summary>
		public Break(): this(TimeSpan.Zero,TimeSpan.Zero)
		{
		}

		/// <summary>
		/// Init.
		/// </summary>
		public Break(TimeSpan beginBreak, TimeSpan endBreak) :this(beginBreak, endBreak, false)
		{
		}


		/// <summary>
		/// Init.
		/// </summary>
		public Break(TimeSpan beginBreak, TimeSpan endBreak, bool extra)
		{
			mBeginBreak = beginBreak;
			mEndBreak = endBreak;
			mExtra = extra;
		}


		/// <summary>
		/// Begining of break.
		/// </summary>
		public System.TimeSpan BeginBreak
		{
			set
			{
				mBeginBreak = value;
			}
			get
			{	
				return mBeginBreak;
			}
		}

		/// <summary>
		/// End of break.
		/// </summary>
		public System.TimeSpan EndBreak
		{
			set
			{
				mEndBreak = value;
			}
			get
			{	
				return mEndBreak;
			}
		}


		public bool Extra
		{
			set {mExtra=value;}
			get {return mExtra;}
		}

	}
}