#region Copyright (c) 2003-2004 ComponentGo!
/*
*********************************************************************
*                                                                   *
*       ComponentGo! Component Library                              *
*                                                                   *
*       Copyright (c) 2003-2004 ComponentGo!                        *
*       ALL RIGHTS RESERVED                                         *
*                                                                   *
*********************************************************************
*/
#endregion

using System;

namespace ComponentGo.Calendars
{
#if !DAILY
	
	/// <summary>
	/// Types of calendars displayed using a <see cref="ComboCalendar"/> control.
	/// </summary>
	[Flags]
	public enum CalendarView
	{
		/// <summary>
		/// A daily calendar. Can contain more than one day. 
		/// </summary>
		Daily			= 0x01,

		/// <summary>
		/// Work week displaying a calendar for 5 workdays.
		/// </summary>
		WorkWeek		= 0x02,

		/// <summary>
		/// Week Calendar,
		/// </summary>
		Weekly			= 0x04,

		/// <summary>
		/// Month Calendar.
		/// </summary>
		Monthly			= 0x08,

		/// <summary>
		/// A continuous calendar in a form of a scheduler control.
		/// </summary>
		Scheduler		= 0x10,
	}

#endif
}
