#region Copyright (c) 2003-2004 ComponentGo!
/*
*********************************************************************
*                                                                   *
*       ComponentGo! Component Library                              *
*                                                                   *
*       Copyright (c) 2003-2004 ComponentGo!                        *
*       ALL RIGHTS RESERVED                                         *
*                                                                   *
*********************************************************************
*/
#endregion

using System;

namespace ComponentGo.Calendars
{
	/// <summary> 
	/// The way a calendar responds to change of date/time on the point of contact of two 
	/// linked appointments <seealso cref="RootCalendar.GrowMode"/> 
	/// </summary> 
	[System.Runtime.InteropServices.ComVisible(true)]
	public enum GrowMode { 
		/// <summary> 
		/// Induces a change of dates and times of two adjacent appointments without affecting 
		/// a change of total duration of all linked appointments.<para/> 
		/// This setting facilitates ex. hotel room reservations. 
		/// I case of changing a date/time appointments are connected, 
		/// it should point to a change of adjacent appointment duration, 
		/// without time change.<para/> 
		/// <c>10...15 + 15...20</c> -> <c>10...17 + 17...20</c> 
		/// </summary> 
		ChangeLinkTime, 
		/// <summary> 
		/// Changed appointment is lengthened of shortened 
		/// and all linked appointments are moved accordingly.<para/> 
		/// Setting useful for project management. 
		/// The appointment duration change is an effect of delay of shortening a previous stage. 
		/// Change of whole project duration and moving all subsequent stages follows.<para/> 
		/// <c>10...15 + 15...20</c> -> <c>10...17 + 17...22</c> 
		/// </summary> 
		MoveLater, 
	} 
}
