#region Copyright (c) 2003-2004 ComponentGo!
/*
*********************************************************************
*                                                                   *
*       ComponentGo! Component Library                              *
*                                                                   *
*       Copyright (c) 2003-2004 ComponentGo!                        *
*       ALL RIGHTS RESERVED                                         *
*                                                                   *
*********************************************************************
*/
#endregion

using System;

namespace ComponentGo.Calendars
{
	/// <summary>
	/// Set the resolution (precision) the hours are displayed with.
	/// <seealso cref="BaseCalendar.HoursResolution"/>
	/// </summary>
	[System.Runtime.InteropServices.ComVisible(true)]
	public enum HoursResolutions { 
		/// <summary>
		/// Resolution of one day. 
		/// Available only in a <see cref="ResourceScheduler"/> control.
		/// </summary>
		OneDay,

		/// <summary>
		/// Resolution of half a day (twelve hours). 
		/// Available only in a <see cref="ResourceScheduler"/> control.
		/// </summary>
		Twelve,
		
		/// <summary>
		/// 1 hour resolution.
		/// </summary>
		One, 

		/// <summary>
		/// Half an hour (30 min) resolution.
		/// </summary>
		Half, 

		/// <summary>
		/// Quarter (15 min) resolution.
		/// </summary>
		Quart, 

		/// <summary>
		/// Ten minutes (10 min) resolution.
		/// </summary>
		TenMinutes, 

		/// <summary>
		/// Six minutes (6 min) resolution.
		/// </summary>
		SixMinutes, 

		/// <summary>
		/// Five minutes (5 min) resolution.
		/// </summary>
		FiveMinutes, 

		/// <summary>
		/// One minute (1 min) resolution.
		/// </summary>
		Minute,

		/// <summary>
		/// 15 seconds' resolution.
		/// </summary>
		QuarterMinute, 

		/// <summary>
		/// One second (1 second) resolution.
		/// </summary>
		Second, 
	}

}
