#region Copyright (c) 2003-2005 ComponentGo!
/*
*********************************************************************
*                                                                   *
*       ComponentGo! Component Library                              *
*                                                                   *
*       Copyright (c) 2003-2005 ComponentGo!                        *
*       ALL RIGHTS RESERVED                                         *
*                                                                   *
*********************************************************************
*/
#endregion

using System;

namespace ComponentGo.Calendars
{
	/// <summary>
	/// Ways to print a calendar.
	/// </summary>
	/// <remarks>
	/// Determines calendar's elements to be printed. To change settings,
	/// a <see cref="RootCalendar.PrintingMode"/> property should be used.
	/// </remarks>
	public enum PrintingMode
	{
		/// <summary>
		/// Calendar is printed in a way it is shown on a screen.
		/// </summary>
		Standard,

		/// <summary>
		/// A simplified version of a calendar in printed. Elements backgrounds 
		/// are not printed. Only frames ant texts in them are printed.
		/// </summary>
		NoBackgrounds,
	}
}
