Imports System.Reflection
Imports System.Resources

''' <summary>
''' The resource wrapper.
''' </summary>
Friend NotInheritable Class Res

    Friend Shared Function GetString(ByVal name As String) As String
        Return ResourceManager.GetString(name)
    End Function

    ''' The resource strings names
    Friend Shared ReadOnly Property DatabaseConnectionFailed() As String
        Get
            Return GetString("DatabaseConnectionFailed")
        End Get
    End Property

    Friend Shared ReadOnly Property DatabaseError() As String
        Get
            Return GetString("DatabaseError")
        End Get
    End Property

    ''' <summary>
    ''' The resource manager accessor.
    ''' </summary>
    ''' <remarks>The property implmentation has lazy-initialization logic.</remarks>
    ''' <value>The resource manager</value>
    Private Shared ReadOnly Property ResourceManager() As ResourceManager
        Get
            If mResourceManager Is Nothing Then
                mResourceManager = New ResourceManager("Phoenix.DataAccess.Resources", [Assembly].GetCallingAssembly())
            End If
            Return mResourceManager
        End Get
    End Property


    Private Shared mResourceManager As ResourceManager = Nothing
End Class
