Imports DevExpress.XtraGrid

Imports Phoenix.DataAccess
Imports Phoenix.Events
Imports Phoenix.Forms
Imports Phoenix.Helpers



Namespace Forms.Dialogs

    Public Class OptionsDialog : Inherits PhoenixFormBase

#Region " Windows Form Designer generated code "

        Public Sub New()
            MyBase.New()

            'This call is required by the Windows Form Designer.
            InitializeComponent()
            mBreaks = New ComponentGo.Calendars.BreakCollection

            'Add any initialization after the InitializeComponent() call
            DailyCalendar1.SelectedAppointmentColor = AppConfig.SelectedAppointmentBackColor
            DailyCalendar1.SelectedAppointmentTextColor = AppConfig.SelectedAppointmentForeColor
            DailyCalendar1.WorkHourColor = AppConfig.WorkHourColor
            DailyCalendar1.WorkHourColorSecond = AppConfig.WorkHourColor2
            DailyCalendar1.FreeHourColor = AppConfig.FreeHourColor
            DailyCalendar1.HoursResolution = AppConfig.ScheduleResolution
            DailyCalendar1.FreeHourColor = AppConfig.FreeHourColor
            DailyCalendar1.ExtraBreakHourColor = AppConfig.ExtraFreeHourColor
            DailyCalendar1.WorkHourColorSecond = AppConfig.WorkHourColor2

        End Sub

        'Form overrides dispose to clean up the component list.
        Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
            If disposing Then
                If Not (components Is Nothing) Then
                    components.Dispose()
                End If
            End If
            MyBase.Dispose(disposing)
        End Sub

        'Required by the Windows Form Designer
        Private components As System.ComponentModel.IContainer

        'NOTE: The following procedure is required by the Windows Form Designer
        'It can be modified using the Windows Form Designer.  
        'Do not modify it using the code editor.
        Friend WithEvents GeneralTabPage As System.Windows.Forms.TabPage
        Friend WithEvents MasterLevelTabPage As System.Windows.Forms.TabPage
        Friend WithEvents OptionsTabControl As System.Windows.Forms.TabControl
        Friend WithEvents MasterLevelGridControl As DevExpress.XtraGrid.GridControl
        Friend WithEvents OkBtn As DevExpress.XtraEditors.SimpleButton
        Friend WithEvents CancelBtn As DevExpress.XtraEditors.SimpleButton
        Friend WithEvents MasterLevelGridView As DevExpress.XtraGrid.Views.Grid.GridView
        Friend WithEvents GridColumnName As DevExpress.XtraGrid.Columns.GridColumn
        Friend WithEvents AddButton As DevExpress.XtraEditors.SimpleButton
        Friend WithEvents DeleteButton As DevExpress.XtraEditors.SimpleButton
        Friend WithEvents OfficeHoursTabPage As System.Windows.Forms.TabPage
        Friend WithEvents btnRemoveWorkTime As DevExpress.XtraEditors.SimpleButton
        Friend WithEvents btnSetWorkTime As DevExpress.XtraEditors.SimpleButton
        Friend WithEvents btnSetHolyday As DevExpress.XtraEditors.SimpleButton
        Friend WithEvents DailyCalendar1 As ComponentGo.Calendars.DailyCalendar
        Friend WithEvents SecurityTab As System.Windows.Forms.TabPage
        Friend WithEvents UserModeButton As System.Windows.Forms.RadioButton
        Friend WithEvents SimpleModeButton As System.Windows.Forms.RadioButton
        Friend WithEvents LevelBox As System.Windows.Forms.GroupBox
        Friend WithEvents OperatorButton As System.Windows.Forms.RadioButton
        Friend WithEvents ManagerButton As System.Windows.Forms.RadioButton
        Friend WithEvents AdministratorButton As System.Windows.Forms.RadioButton
        Friend WithEvents GridColumnIcon As DevExpress.XtraGrid.Columns.GridColumn
        Friend WithEvents IconRI As DevExpress.XtraEditors.Repository.RepositoryItemImageComboBox
        Friend WithEvents ViewPage As System.Windows.Forms.TabPage
        Friend WithEvents LargeIconsCheckBox As DevExpress.XtraEditors.CheckEdit
        Friend WithEvents NameLabel As System.Windows.Forms.Label
        Friend WithEvents NameEdit As DevExpress.XtraEditors.TextEdit
        Friend WithEvents RenameButton As DevExpress.XtraEditors.SimpleButton
        Friend WithEvents OthersTab As System.Windows.Forms.TabPage
        Friend WithEvents Label1 As System.Windows.Forms.Label
        Friend WithEvents Belevel2 As System.Windows.Forms.GroupBox
        Friend WithEvents StrongControlCheck As System.Windows.Forms.CheckBox
        Friend WithEvents IndicateCriticalCheck As System.Windows.Forms.CheckBox
        Friend WithEvents CriticalStockColor As DevExpress.XtraEditors.ColorEdit
        Friend WithEvents GroupBox1 As System.Windows.Forms.GroupBox
        Friend WithEvents Label2 As System.Windows.Forms.Label
        Friend WithEvents OpenTillCheck As System.Windows.Forms.CheckBox
        Friend WithEvents PrintCheck As System.Windows.Forms.CheckBox
        Friend WithEvents GroupBox2 As System.Windows.Forms.GroupBox
        Friend WithEvents Label3 As System.Windows.Forms.Label
        Friend WithEvents SelectedAppointmentColorEdit As DevExpress.XtraEditors.ColorEdit
        Friend WithEvents LabelDefaultColor As System.Windows.Forms.Label
        Friend WithEvents DefaultAppointmentColorEdit As DevExpress.XtraEditors.ColorEdit
        Friend WithEvents LabelOpenAppointment As System.Windows.Forms.Label
        Friend WithEvents OpenAppointmentColorEdit As DevExpress.XtraEditors.ColorEdit
        Friend WithEvents LabelPaidAppointment As System.Windows.Forms.Label
        Friend WithEvents PaidAppointmentColorEdit As DevExpress.XtraEditors.ColorEdit
        Friend WithEvents LabelSelectedAppointment As System.Windows.Forms.Label
        Friend WithEvents PaidAppointmentTextColorEdit As DevExpress.XtraEditors.ColorEdit
        Friend WithEvents OpenAppointmentTextColorEdit As DevExpress.XtraEditors.ColorEdit
        Friend WithEvents DefaultAppointmentTextColorEdit As DevExpress.XtraEditors.ColorEdit
        Friend WithEvents SelectedAppointmentTextColorEdit As DevExpress.XtraEditors.ColorEdit
        Friend WithEvents GroupBox3 As System.Windows.Forms.GroupBox
        Friend WithEvents Label4 As System.Windows.Forms.Label
        Friend WithEvents GroupBox4 As System.Windows.Forms.GroupBox
        Friend WithEvents Label5 As System.Windows.Forms.Label
        Friend WithEvents SilenceEmployeeDeletion As DevExpress.XtraEditors.CheckEdit
        Friend WithEvents SilenceProductDeletion As DevExpress.XtraEditors.CheckEdit
        Friend WithEvents SilenceServiceDeletion As DevExpress.XtraEditors.CheckEdit
        Friend WithEvents SilenceClientsDeletion As DevExpress.XtraEditors.CheckEdit
        Friend WithEvents SilenceEmployeesDeletion As DevExpress.XtraEditors.CheckEdit
        Friend WithEvents SilenceProductsDeletion As DevExpress.XtraEditors.CheckEdit
        Friend WithEvents SilenceServicesDeletion As DevExpress.XtraEditors.CheckEdit
        Friend WithEvents SilenceClientDeletion As DevExpress.XtraEditors.CheckEdit
        Friend WithEvents SilenceAppointmentsDeletion As DevExpress.XtraEditors.CheckEdit
        Friend WithEvents SilenceAppointmentDeletion As DevExpress.XtraEditors.CheckEdit
        Friend WithEvents BusyTimeTextColorEdit As DevExpress.XtraEditors.ColorEdit
        Friend WithEvents LabelBusyTime As System.Windows.Forms.Label
        Friend WithEvents BusyTimeColorEdit As DevExpress.XtraEditors.ColorEdit
        Friend WithEvents Label6 As System.Windows.Forms.Label
        Friend WithEvents Label7 As System.Windows.Forms.Label
        Friend WithEvents Label8 As System.Windows.Forms.Label
        Friend WithEvents GroupBox5 As System.Windows.Forms.GroupBox
        Friend WithEvents RightButton As DevExpress.XtraEditors.CheckEdit
        Friend WithEvents LeftButton As DevExpress.XtraEditors.CheckEdit
        Friend WithEvents GroupBox6 As System.Windows.Forms.GroupBox
        Friend WithEvents Label9 As System.Windows.Forms.Label
        Friend WithEvents GroupBox7 As System.Windows.Forms.GroupBox
        Friend WithEvents Label10 As System.Windows.Forms.Label
        Friend WithEvents lblNumColumns As System.Windows.Forms.Label
        Friend WithEvents NumColumnsBox As DevExpress.XtraEditors.SpinEdit
        Friend WithEvents GroupBox8 As System.Windows.Forms.GroupBox
        Friend WithEvents Label11 As System.Windows.Forms.Label
        Friend WithEvents GroupBox9 As System.Windows.Forms.GroupBox
        Friend WithEvents Label12 As System.Windows.Forms.Label
        Friend WithEvents EnableAutoLogoutBox As System.Windows.Forms.CheckBox
        Friend WithEvents TimeoutBox As DevExpress.XtraEditors.SpinEdit
        Friend WithEvents Label13 As System.Windows.Forms.Label
        Friend WithEvents Label14 As System.Windows.Forms.Label
        Friend WithEvents Label15 As System.Windows.Forms.Label
        Friend WithEvents DayViewResolutionBox As DevExpress.XtraEditors.ComboBoxEdit
        Friend WithEvents FitToPageCheckBox As DevExpress.XtraEditors.CheckEdit
        <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
            Dim resources As System.Resources.ResourceManager = New System.Resources.ResourceManager(GetType(OptionsDialog))
            Me.OptionsTabControl = New System.Windows.Forms.TabControl
            Me.GeneralTabPage = New System.Windows.Forms.TabPage
            Me.SilenceAppointmentsDeletion = New DevExpress.XtraEditors.CheckEdit
            Me.SilenceAppointmentDeletion = New DevExpress.XtraEditors.CheckEdit
            Me.SilenceServicesDeletion = New DevExpress.XtraEditors.CheckEdit
            Me.SilenceProductsDeletion = New DevExpress.XtraEditors.CheckEdit
            Me.SilenceEmployeesDeletion = New DevExpress.XtraEditors.CheckEdit
            Me.SilenceClientsDeletion = New DevExpress.XtraEditors.CheckEdit
            Me.SilenceEmployeeDeletion = New DevExpress.XtraEditors.CheckEdit
            Me.SilenceProductDeletion = New DevExpress.XtraEditors.CheckEdit
            Me.SilenceServiceDeletion = New DevExpress.XtraEditors.CheckEdit
            Me.SilenceClientDeletion = New DevExpress.XtraEditors.CheckEdit
            Me.GroupBox4 = New System.Windows.Forms.GroupBox
            Me.Label5 = New System.Windows.Forms.Label
            Me.GroupBox3 = New System.Windows.Forms.GroupBox
            Me.Label4 = New System.Windows.Forms.Label
            Me.NameEdit = New DevExpress.XtraEditors.TextEdit
            Me.NameLabel = New System.Windows.Forms.Label
            Me.SecurityTab = New System.Windows.Forms.TabPage
            Me.Label14 = New System.Windows.Forms.Label
            Me.TimeoutBox = New DevExpress.XtraEditors.SpinEdit
            Me.Label13 = New System.Windows.Forms.Label
            Me.EnableAutoLogoutBox = New System.Windows.Forms.CheckBox
            Me.GroupBox9 = New System.Windows.Forms.GroupBox
            Me.Label12 = New System.Windows.Forms.Label
            Me.GroupBox8 = New System.Windows.Forms.GroupBox
            Me.Label11 = New System.Windows.Forms.Label
            Me.LevelBox = New System.Windows.Forms.GroupBox
            Me.OperatorButton = New System.Windows.Forms.RadioButton
            Me.ManagerButton = New System.Windows.Forms.RadioButton
            Me.AdministratorButton = New System.Windows.Forms.RadioButton
            Me.UserModeButton = New System.Windows.Forms.RadioButton
            Me.SimpleModeButton = New System.Windows.Forms.RadioButton
            Me.ViewPage = New System.Windows.Forms.TabPage
            Me.FitToPageCheckBox = New DevExpress.XtraEditors.CheckEdit
            Me.DayViewResolutionBox = New DevExpress.XtraEditors.ComboBoxEdit
            Me.Label15 = New System.Windows.Forms.Label
            Me.NumColumnsBox = New DevExpress.XtraEditors.SpinEdit
            Me.lblNumColumns = New System.Windows.Forms.Label
            Me.GroupBox7 = New System.Windows.Forms.GroupBox
            Me.Label10 = New System.Windows.Forms.Label
            Me.GroupBox6 = New System.Windows.Forms.GroupBox
            Me.Label9 = New System.Windows.Forms.Label
            Me.LeftButton = New DevExpress.XtraEditors.CheckEdit
            Me.RightButton = New DevExpress.XtraEditors.CheckEdit
            Me.GroupBox5 = New System.Windows.Forms.GroupBox
            Me.Label8 = New System.Windows.Forms.Label
            Me.LargeIconsCheckBox = New DevExpress.XtraEditors.CheckEdit
            Me.OfficeHoursTabPage = New System.Windows.Forms.TabPage
            Me.DailyCalendar1 = New ComponentGo.Calendars.DailyCalendar
            Me.btnRemoveWorkTime = New DevExpress.XtraEditors.SimpleButton
            Me.btnSetWorkTime = New DevExpress.XtraEditors.SimpleButton
            Me.btnSetHolyday = New DevExpress.XtraEditors.SimpleButton
            Me.MasterLevelTabPage = New System.Windows.Forms.TabPage
            Me.MasterLevelGridControl = New DevExpress.XtraGrid.GridControl
            Me.MasterLevelGridView = New DevExpress.XtraGrid.Views.Grid.GridView
            Me.GridColumnIcon = New DevExpress.XtraGrid.Columns.GridColumn
            Me.IconRI = New DevExpress.XtraEditors.Repository.RepositoryItemImageComboBox
            Me.GridColumnName = New DevExpress.XtraGrid.Columns.GridColumn
            Me.RenameButton = New DevExpress.XtraEditors.SimpleButton
            Me.AddButton = New DevExpress.XtraEditors.SimpleButton
            Me.DeleteButton = New DevExpress.XtraEditors.SimpleButton
            Me.OthersTab = New System.Windows.Forms.TabPage
            Me.Label7 = New System.Windows.Forms.Label
            Me.Label6 = New System.Windows.Forms.Label
            Me.BusyTimeTextColorEdit = New DevExpress.XtraEditors.ColorEdit
            Me.LabelBusyTime = New System.Windows.Forms.Label
            Me.BusyTimeColorEdit = New DevExpress.XtraEditors.ColorEdit
            Me.SelectedAppointmentTextColorEdit = New DevExpress.XtraEditors.ColorEdit
            Me.PaidAppointmentTextColorEdit = New DevExpress.XtraEditors.ColorEdit
            Me.OpenAppointmentTextColorEdit = New DevExpress.XtraEditors.ColorEdit
            Me.DefaultAppointmentTextColorEdit = New DevExpress.XtraEditors.ColorEdit
            Me.LabelPaidAppointment = New System.Windows.Forms.Label
            Me.PaidAppointmentColorEdit = New DevExpress.XtraEditors.ColorEdit
            Me.LabelOpenAppointment = New System.Windows.Forms.Label
            Me.OpenAppointmentColorEdit = New DevExpress.XtraEditors.ColorEdit
            Me.LabelDefaultColor = New System.Windows.Forms.Label
            Me.DefaultAppointmentColorEdit = New DevExpress.XtraEditors.ColorEdit
            Me.LabelSelectedAppointment = New System.Windows.Forms.Label
            Me.SelectedAppointmentColorEdit = New DevExpress.XtraEditors.ColorEdit
            Me.GroupBox2 = New System.Windows.Forms.GroupBox
            Me.Label3 = New System.Windows.Forms.Label
            Me.PrintCheck = New System.Windows.Forms.CheckBox
            Me.OpenTillCheck = New System.Windows.Forms.CheckBox
            Me.GroupBox1 = New System.Windows.Forms.GroupBox
            Me.Label2 = New System.Windows.Forms.Label
            Me.CriticalStockColor = New DevExpress.XtraEditors.ColorEdit
            Me.IndicateCriticalCheck = New System.Windows.Forms.CheckBox
            Me.StrongControlCheck = New System.Windows.Forms.CheckBox
            Me.Belevel2 = New System.Windows.Forms.GroupBox
            Me.Label1 = New System.Windows.Forms.Label
            Me.OkBtn = New DevExpress.XtraEditors.SimpleButton
            Me.CancelBtn = New DevExpress.XtraEditors.SimpleButton
            Me.OptionsTabControl.SuspendLayout()
            Me.GeneralTabPage.SuspendLayout()
            CType(Me.SilenceAppointmentsDeletion.Properties, System.ComponentModel.ISupportInitialize).BeginInit()
            CType(Me.SilenceAppointmentDeletion.Properties, System.ComponentModel.ISupportInitialize).BeginInit()
            CType(Me.SilenceServicesDeletion.Properties, System.ComponentModel.ISupportInitialize).BeginInit()
            CType(Me.SilenceProductsDeletion.Properties, System.ComponentModel.ISupportInitialize).BeginInit()
            CType(Me.SilenceEmployeesDeletion.Properties, System.ComponentModel.ISupportInitialize).BeginInit()
            CType(Me.SilenceClientsDeletion.Properties, System.ComponentModel.ISupportInitialize).BeginInit()
            CType(Me.SilenceEmployeeDeletion.Properties, System.ComponentModel.ISupportInitialize).BeginInit()
            CType(Me.SilenceProductDeletion.Properties, System.ComponentModel.ISupportInitialize).BeginInit()
            CType(Me.SilenceServiceDeletion.Properties, System.ComponentModel.ISupportInitialize).BeginInit()
            CType(Me.SilenceClientDeletion.Properties, System.ComponentModel.ISupportInitialize).BeginInit()
            CType(Me.NameEdit.Properties, System.ComponentModel.ISupportInitialize).BeginInit()
            Me.SecurityTab.SuspendLayout()
            CType(Me.TimeoutBox.Properties, System.ComponentModel.ISupportInitialize).BeginInit()
            Me.LevelBox.SuspendLayout()
            Me.ViewPage.SuspendLayout()
            CType(Me.FitToPageCheckBox.Properties, System.ComponentModel.ISupportInitialize).BeginInit()
            CType(Me.DayViewResolutionBox.Properties, System.ComponentModel.ISupportInitialize).BeginInit()
            CType(Me.NumColumnsBox.Properties, System.ComponentModel.ISupportInitialize).BeginInit()
            CType(Me.LeftButton.Properties, System.ComponentModel.ISupportInitialize).BeginInit()
            CType(Me.RightButton.Properties, System.ComponentModel.ISupportInitialize).BeginInit()
            CType(Me.LargeIconsCheckBox.Properties, System.ComponentModel.ISupportInitialize).BeginInit()
            Me.OfficeHoursTabPage.SuspendLayout()
            Me.MasterLevelTabPage.SuspendLayout()
            CType(Me.MasterLevelGridControl, System.ComponentModel.ISupportInitialize).BeginInit()
            CType(Me.MasterLevelGridView, System.ComponentModel.ISupportInitialize).BeginInit()
            CType(Me.IconRI, System.ComponentModel.ISupportInitialize).BeginInit()
            Me.OthersTab.SuspendLayout()
            CType(Me.BusyTimeTextColorEdit.Properties, System.ComponentModel.ISupportInitialize).BeginInit()
            CType(Me.BusyTimeColorEdit.Properties, System.ComponentModel.ISupportInitialize).BeginInit()
            CType(Me.SelectedAppointmentTextColorEdit.Properties, System.ComponentModel.ISupportInitialize).BeginInit()
            CType(Me.PaidAppointmentTextColorEdit.Properties, System.ComponentModel.ISupportInitialize).BeginInit()
            CType(Me.OpenAppointmentTextColorEdit.Properties, System.ComponentModel.ISupportInitialize).BeginInit()
            CType(Me.DefaultAppointmentTextColorEdit.Properties, System.ComponentModel.ISupportInitialize).BeginInit()
            CType(Me.PaidAppointmentColorEdit.Properties, System.ComponentModel.ISupportInitialize).BeginInit()
            CType(Me.OpenAppointmentColorEdit.Properties, System.ComponentModel.ISupportInitialize).BeginInit()
            CType(Me.DefaultAppointmentColorEdit.Properties, System.ComponentModel.ISupportInitialize).BeginInit()
            CType(Me.SelectedAppointmentColorEdit.Properties, System.ComponentModel.ISupportInitialize).BeginInit()
            CType(Me.CriticalStockColor.Properties, System.ComponentModel.ISupportInitialize).BeginInit()
            Me.SuspendLayout()
            '
            'OptionsTabControl
            '
            Me.OptionsTabControl.Anchor = CType((((System.Windows.Forms.AnchorStyles.Top Or System.Windows.Forms.AnchorStyles.Bottom) _
                        Or System.Windows.Forms.AnchorStyles.Left) _
                        Or System.Windows.Forms.AnchorStyles.Right), System.Windows.Forms.AnchorStyles)
            Me.OptionsTabControl.Controls.Add(Me.GeneralTabPage)
            Me.OptionsTabControl.Controls.Add(Me.SecurityTab)
            Me.OptionsTabControl.Controls.Add(Me.ViewPage)
            Me.OptionsTabControl.Controls.Add(Me.OfficeHoursTabPage)
            Me.OptionsTabControl.Controls.Add(Me.MasterLevelTabPage)
            Me.OptionsTabControl.Controls.Add(Me.OthersTab)
            Me.OptionsTabControl.Location = New System.Drawing.Point(0, 0)
            Me.OptionsTabControl.Name = "OptionsTabControl"
            Me.OptionsTabControl.SelectedIndex = 0
            Me.OptionsTabControl.Size = New System.Drawing.Size(440, 362)
            Me.OptionsTabControl.TabIndex = 0
            '
            'GeneralTabPage
            '
            Me.GeneralTabPage.Controls.Add(Me.SilenceAppointmentsDeletion)
            Me.GeneralTabPage.Controls.Add(Me.SilenceAppointmentDeletion)
            Me.GeneralTabPage.Controls.Add(Me.SilenceServicesDeletion)
            Me.GeneralTabPage.Controls.Add(Me.SilenceProductsDeletion)
            Me.GeneralTabPage.Controls.Add(Me.SilenceEmployeesDeletion)
            Me.GeneralTabPage.Controls.Add(Me.SilenceClientsDeletion)
            Me.GeneralTabPage.Controls.Add(Me.SilenceEmployeeDeletion)
            Me.GeneralTabPage.Controls.Add(Me.SilenceProductDeletion)
            Me.GeneralTabPage.Controls.Add(Me.SilenceServiceDeletion)
            Me.GeneralTabPage.Controls.Add(Me.SilenceClientDeletion)
            Me.GeneralTabPage.Controls.Add(Me.GroupBox4)
            Me.GeneralTabPage.Controls.Add(Me.Label5)
            Me.GeneralTabPage.Controls.Add(Me.GroupBox3)
            Me.GeneralTabPage.Controls.Add(Me.Label4)
            Me.GeneralTabPage.Controls.Add(Me.NameEdit)
            Me.GeneralTabPage.Controls.Add(Me.NameLabel)
            Me.GeneralTabPage.Location = New System.Drawing.Point(4, 22)
            Me.GeneralTabPage.Name = "GeneralTabPage"
            Me.GeneralTabPage.Size = New System.Drawing.Size(432, 336)
            Me.GeneralTabPage.TabIndex = 0
            Me.GeneralTabPage.Text = "General"
            '
            'SilenceAppointmentsDeletion
            '
            Me.SilenceAppointmentsDeletion.Location = New System.Drawing.Point(112, 240)
            Me.SilenceAppointmentsDeletion.Name = "SilenceAppointmentsDeletion"
            '
            'SilenceAppointmentsDeletion.Properties
            '
            Me.SilenceAppointmentsDeletion.Properties.Caption = "Multiple Appoint&ment  Removing"
            Me.SilenceAppointmentsDeletion.Size = New System.Drawing.Size(200, 19)
            Me.SilenceAppointmentsDeletion.TabIndex = 15
            '
            'SilenceAppointmentDeletion
            '
            Me.SilenceAppointmentDeletion.Location = New System.Drawing.Point(112, 216)
            Me.SilenceAppointmentDeletion.Name = "SilenceAppointmentDeletion"
            '
            'SilenceAppointmentDeletion.Properties
            '
            Me.SilenceAppointmentDeletion.Properties.Caption = "Appoi&ntment Removing"
            Me.SilenceAppointmentDeletion.Size = New System.Drawing.Size(152, 19)
            Me.SilenceAppointmentDeletion.TabIndex = 14
            '
            'SilenceServicesDeletion
            '
            Me.SilenceServicesDeletion.Location = New System.Drawing.Point(256, 120)
            Me.SilenceServicesDeletion.Name = "SilenceServicesDeletion"
            '
            'SilenceServicesDeletion.Properties
            '
            Me.SilenceServicesDeletion.Properties.Caption = "Multiple Ser&vices Removing"
            Me.SilenceServicesDeletion.Size = New System.Drawing.Size(168, 19)
            Me.SilenceServicesDeletion.TabIndex = 9
            '
            'SilenceProductsDeletion
            '
            Me.SilenceProductsDeletion.Location = New System.Drawing.Point(256, 144)
            Me.SilenceProductsDeletion.Name = "SilenceProductsDeletion"
            '
            'SilenceProductsDeletion.Properties
            '
            Me.SilenceProductsDeletion.Properties.Caption = "Multiple Pr&oducts Removing"
            Me.SilenceProductsDeletion.Size = New System.Drawing.Size(168, 19)
            Me.SilenceProductsDeletion.TabIndex = 11
            '
            'SilenceEmployeesDeletion
            '
            Me.SilenceEmployeesDeletion.Location = New System.Drawing.Point(112, 192)
            Me.SilenceEmployeesDeletion.Name = "SilenceEmployeesDeletion"
            '
            'SilenceEmployeesDeletion.Properties
            '
            Me.SilenceEmployeesDeletion.Properties.Caption = "Multiple St&aff Members Removing"
            Me.SilenceEmployeesDeletion.Size = New System.Drawing.Size(200, 19)
            Me.SilenceEmployeesDeletion.TabIndex = 13
            '
            'SilenceClientsDeletion
            '
            Me.SilenceClientsDeletion.Location = New System.Drawing.Point(256, 96)
            Me.SilenceClientsDeletion.Name = "SilenceClientsDeletion"
            '
            'SilenceClientsDeletion.Properties
            '
            Me.SilenceClientsDeletion.Properties.Caption = "Multiple Cl&ients Removing"
            Me.SilenceClientsDeletion.Size = New System.Drawing.Size(160, 19)
            Me.SilenceClientsDeletion.TabIndex = 7
            '
            'SilenceEmployeeDeletion
            '
            Me.SilenceEmployeeDeletion.Location = New System.Drawing.Point(112, 168)
            Me.SilenceEmployeeDeletion.Name = "SilenceEmployeeDeletion"
            '
            'SilenceEmployeeDeletion.Properties
            '
            Me.SilenceEmployeeDeletion.Properties.Caption = "Sta&ff Member Removing"
            Me.SilenceEmployeeDeletion.Size = New System.Drawing.Size(152, 19)
            Me.SilenceEmployeeDeletion.TabIndex = 12
            '
            'SilenceProductDeletion
            '
            Me.SilenceProductDeletion.Location = New System.Drawing.Point(112, 144)
            Me.SilenceProductDeletion.Name = "SilenceProductDeletion"
            '
            'SilenceProductDeletion.Properties
            '
            Me.SilenceProductDeletion.Properties.Caption = "&Product Removing"
            Me.SilenceProductDeletion.Size = New System.Drawing.Size(144, 19)
            Me.SilenceProductDeletion.TabIndex = 10
            '
            'SilenceServiceDeletion
            '
            Me.SilenceServiceDeletion.Location = New System.Drawing.Point(112, 120)
            Me.SilenceServiceDeletion.Name = "SilenceServiceDeletion"
            '
            'SilenceServiceDeletion.Properties
            '
            Me.SilenceServiceDeletion.Properties.Caption = "S&ervice Removing"
            Me.SilenceServiceDeletion.Size = New System.Drawing.Size(144, 19)
            Me.SilenceServiceDeletion.TabIndex = 8
            '
            'SilenceClientDeletion
            '
            Me.SilenceClientDeletion.Location = New System.Drawing.Point(112, 96)
            Me.SilenceClientDeletion.Name = "SilenceClientDeletion"
            '
            'SilenceClientDeletion.Properties
            '
            Me.SilenceClientDeletion.Properties.Caption = "C&lient Removing"
            Me.SilenceClientDeletion.Size = New System.Drawing.Size(120, 19)
            Me.SilenceClientDeletion.TabIndex = 6
            '
            'GroupBox4
            '
            Me.GroupBox4.Anchor = CType(((System.Windows.Forms.AnchorStyles.Top Or System.Windows.Forms.AnchorStyles.Left) _
                        Or System.Windows.Forms.AnchorStyles.Right), System.Windows.Forms.AnchorStyles)
            Me.GroupBox4.Location = New System.Drawing.Point(112, 80)
            Me.GroupBox4.Name = "GroupBox4"
            Me.GroupBox4.Size = New System.Drawing.Size(302, 3)
            Me.GroupBox4.TabIndex = 5
            Me.GroupBox4.TabStop = False
            '
            'Label5
            '
            Me.Label5.Location = New System.Drawing.Point(8, 74)
            Me.Label5.Name = "Label5"
            Me.Label5.Size = New System.Drawing.Size(88, 16)
            Me.Label5.TabIndex = 4
            Me.Label5.Text = "Conformations"
            '
            'GroupBox3
            '
            Me.GroupBox3.Anchor = CType(((System.Windows.Forms.AnchorStyles.Top Or System.Windows.Forms.AnchorStyles.Left) _
                        Or System.Windows.Forms.AnchorStyles.Right), System.Windows.Forms.AnchorStyles)
            Me.GroupBox3.Location = New System.Drawing.Point(112, 22)
            Me.GroupBox3.Name = "GroupBox3"
            Me.GroupBox3.Size = New System.Drawing.Size(302, 3)
            Me.GroupBox3.TabIndex = 1
            Me.GroupBox3.TabStop = False
            '
            'Label4
            '
            Me.Label4.Location = New System.Drawing.Point(8, 16)
            Me.Label4.Name = "Label4"
            Me.Label4.Size = New System.Drawing.Size(72, 16)
            Me.Label4.TabIndex = 0
            Me.Label4.Text = "Reports"
            '
            'NameEdit
            '
            Me.NameEdit.EditValue = ""
            Me.NameEdit.Location = New System.Drawing.Point(184, 32)
            Me.NameEdit.Name = "NameEdit"
            Me.NameEdit.Size = New System.Drawing.Size(232, 20)
            Me.NameEdit.TabIndex = 3
            '
            'NameLabel
            '
            Me.NameLabel.Location = New System.Drawing.Point(112, 34)
            Me.NameLabel.Name = "NameLabel"
            Me.NameLabel.Size = New System.Drawing.Size(72, 16)
            Me.NameLabel.TabIndex = 2
            Me.NameLabel.Text = "&Salon Name:"
            '
            'SecurityTab
            '
            Me.SecurityTab.Controls.Add(Me.Label14)
            Me.SecurityTab.Controls.Add(Me.TimeoutBox)
            Me.SecurityTab.Controls.Add(Me.Label13)
            Me.SecurityTab.Controls.Add(Me.EnableAutoLogoutBox)
            Me.SecurityTab.Controls.Add(Me.GroupBox9)
            Me.SecurityTab.Controls.Add(Me.Label12)
            Me.SecurityTab.Controls.Add(Me.GroupBox8)
            Me.SecurityTab.Controls.Add(Me.Label11)
            Me.SecurityTab.Controls.Add(Me.LevelBox)
            Me.SecurityTab.Controls.Add(Me.UserModeButton)
            Me.SecurityTab.Controls.Add(Me.SimpleModeButton)
            Me.SecurityTab.Location = New System.Drawing.Point(4, 22)
            Me.SecurityTab.Name = "SecurityTab"
            Me.SecurityTab.Size = New System.Drawing.Size(432, 336)
            Me.SecurityTab.TabIndex = 3
            Me.SecurityTab.Text = "Security"
            '
            'Label14
            '
            Me.Label14.Location = New System.Drawing.Point(240, 248)
            Me.Label14.Name = "Label14"
            Me.Label14.Size = New System.Drawing.Size(32, 16)
            Me.Label14.TabIndex = 23
            Me.Label14.Text = "mins"
            '
            'TimeoutBox
            '
            Me.TimeoutBox.EditValue = 1
            Me.TimeoutBox.Location = New System.Drawing.Point(184, 246)
            Me.TimeoutBox.Name = "TimeoutBox"
            '
            'TimeoutBox.Properties
            '
            Me.TimeoutBox.Properties.Buttons.AddRange(New DevExpress.XtraEditors.Controls.EditorButton() {New DevExpress.XtraEditors.Controls.EditorButton})
            Me.TimeoutBox.Properties.Enabled = False
            Me.TimeoutBox.Properties.IsFloatValue = False
            Me.TimeoutBox.Properties.MaxValue = New Decimal(New Integer() {25, 0, 0, 0})
            Me.TimeoutBox.Properties.MinValue = New Decimal(New Integer() {1, 0, 0, 0})
            Me.TimeoutBox.Properties.UseCtrlIncrement = False
            Me.TimeoutBox.Size = New System.Drawing.Size(48, 20)
            Me.TimeoutBox.TabIndex = 22
            '
            'Label13
            '
            Me.Label13.Location = New System.Drawing.Point(120, 248)
            Me.Label13.Name = "Label13"
            Me.Label13.Size = New System.Drawing.Size(48, 16)
            Me.Label13.TabIndex = 21
            Me.Label13.Text = "Timeout:"
            '
            'EnableAutoLogoutBox
            '
            Me.EnableAutoLogoutBox.Location = New System.Drawing.Point(120, 216)
            Me.EnableAutoLogoutBox.Name = "EnableAutoLogoutBox"
            Me.EnableAutoLogoutBox.Size = New System.Drawing.Size(152, 24)
            Me.EnableAutoLogoutBox.TabIndex = 20
            Me.EnableAutoLogoutBox.Text = "&Enable Auto Logout"
            '
            'GroupBox9
            '
            Me.GroupBox9.Anchor = CType(((System.Windows.Forms.AnchorStyles.Top Or System.Windows.Forms.AnchorStyles.Left) _
                        Or System.Windows.Forms.AnchorStyles.Right), System.Windows.Forms.AnchorStyles)
            Me.GroupBox9.Location = New System.Drawing.Point(112, 208)
            Me.GroupBox9.Name = "GroupBox9"
            Me.GroupBox9.Size = New System.Drawing.Size(302, 3)
            Me.GroupBox9.TabIndex = 7
            Me.GroupBox9.TabStop = False
            '
            'Label12
            '
            Me.Label12.Location = New System.Drawing.Point(8, 204)
            Me.Label12.Name = "Label12"
            Me.Label12.TabIndex = 6
            Me.Label12.Text = "Auto Logout"
            '
            'GroupBox8
            '
            Me.GroupBox8.Anchor = CType(((System.Windows.Forms.AnchorStyles.Top Or System.Windows.Forms.AnchorStyles.Left) _
                        Or System.Windows.Forms.AnchorStyles.Right), System.Windows.Forms.AnchorStyles)
            Me.GroupBox8.Location = New System.Drawing.Point(112, 22)
            Me.GroupBox8.Name = "GroupBox8"
            Me.GroupBox8.Size = New System.Drawing.Size(302, 3)
            Me.GroupBox8.TabIndex = 5
            Me.GroupBox8.TabStop = False
            '
            'Label11
            '
            Me.Label11.Location = New System.Drawing.Point(8, 16)
            Me.Label11.Name = "Label11"
            Me.Label11.TabIndex = 4
            Me.Label11.Text = "Security Mode"
            '
            'LevelBox
            '
            Me.LevelBox.Controls.Add(Me.OperatorButton)
            Me.LevelBox.Controls.Add(Me.ManagerButton)
            Me.LevelBox.Controls.Add(Me.AdministratorButton)
            Me.LevelBox.Location = New System.Drawing.Point(168, 56)
            Me.LevelBox.Name = "LevelBox"
            Me.LevelBox.Size = New System.Drawing.Size(216, 96)
            Me.LevelBox.TabIndex = 3
            Me.LevelBox.TabStop = False
            Me.LevelBox.Text = "Security Level"
            '
            'OperatorButton
            '
            Me.OperatorButton.Location = New System.Drawing.Point(16, 64)
            Me.OperatorButton.Name = "OperatorButton"
            Me.OperatorButton.TabIndex = 2
            Me.OperatorButton.Text = "&Operator"
            '
            'ManagerButton
            '
            Me.ManagerButton.Location = New System.Drawing.Point(16, 40)
            Me.ManagerButton.Name = "ManagerButton"
            Me.ManagerButton.TabIndex = 1
            Me.ManagerButton.Text = "&Manager"
            '
            'AdministratorButton
            '
            Me.AdministratorButton.Location = New System.Drawing.Point(16, 16)
            Me.AdministratorButton.Name = "AdministratorButton"
            Me.AdministratorButton.TabIndex = 0
            Me.AdministratorButton.TabStop = True
            Me.AdministratorButton.Text = "&Administrator"
            '
            'UserModeButton
            '
            Me.UserModeButton.Location = New System.Drawing.Point(120, 160)
            Me.UserModeButton.Name = "UserModeButton"
            Me.UserModeButton.TabIndex = 2
            Me.UserModeButton.Text = "&User Mode"
            '
            'SimpleModeButton
            '
            Me.SimpleModeButton.Checked = True
            Me.SimpleModeButton.Location = New System.Drawing.Point(120, 32)
            Me.SimpleModeButton.Name = "SimpleModeButton"
            Me.SimpleModeButton.TabIndex = 1
            Me.SimpleModeButton.TabStop = True
            Me.SimpleModeButton.Text = "&Simple Mode"
            '
            'ViewPage
            '
            Me.ViewPage.Controls.Add(Me.FitToPageCheckBox)
            Me.ViewPage.Controls.Add(Me.DayViewResolutionBox)
            Me.ViewPage.Controls.Add(Me.Label15)
            Me.ViewPage.Controls.Add(Me.NumColumnsBox)
            Me.ViewPage.Controls.Add(Me.lblNumColumns)
            Me.ViewPage.Controls.Add(Me.GroupBox7)
            Me.ViewPage.Controls.Add(Me.Label10)
            Me.ViewPage.Controls.Add(Me.GroupBox6)
            Me.ViewPage.Controls.Add(Me.Label9)
            Me.ViewPage.Controls.Add(Me.LeftButton)
            Me.ViewPage.Controls.Add(Me.RightButton)
            Me.ViewPage.Controls.Add(Me.GroupBox5)
            Me.ViewPage.Controls.Add(Me.Label8)
            Me.ViewPage.Controls.Add(Me.LargeIconsCheckBox)
            Me.ViewPage.Location = New System.Drawing.Point(4, 22)
            Me.ViewPage.Name = "ViewPage"
            Me.ViewPage.Size = New System.Drawing.Size(432, 336)
            Me.ViewPage.TabIndex = 4
            Me.ViewPage.Text = "View"
            '
            'FitToPageCheckBox
            '
            Me.FitToPageCheckBox.Location = New System.Drawing.Point(120, 248)
            Me.FitToPageCheckBox.Name = "FitToPageCheckBox"
            '
            'FitToPageCheckBox.Properties
            '
            Me.FitToPageCheckBox.Properties.Caption = "&Print All Day Calendar"
            Me.FitToPageCheckBox.Size = New System.Drawing.Size(136, 19)
            Me.FitToPageCheckBox.TabIndex = 13
            '
            'DayViewResolutionBox
            '
            Me.DayViewResolutionBox.EditValue = ""
            Me.DayViewResolutionBox.Location = New System.Drawing.Point(296, 214)
            Me.DayViewResolutionBox.Name = "DayViewResolutionBox"
            '
            'DayViewResolutionBox.Properties
            '
            Me.DayViewResolutionBox.Properties.Buttons.AddRange(New DevExpress.XtraEditors.Controls.EditorButton() {New DevExpress.XtraEditors.Controls.EditorButton(DevExpress.XtraEditors.Controls.ButtonPredefines.Combo)})
            Me.DayViewResolutionBox.Properties.DropDownRows = 6
            Me.DayViewResolutionBox.Properties.Items.AddRange(New Object() {"One Hour", "Half Hour", "Quarter Hour", "Ten Minutes", "Six Minutes", "Five Minutes", "", ""})
            Me.DayViewResolutionBox.Properties.TextEditStyle = DevExpress.XtraEditors.Controls.TextEditStyles.DisableTextEditor
            Me.DayViewResolutionBox.Size = New System.Drawing.Size(120, 20)
            Me.DayViewResolutionBox.TabIndex = 12
            '
            'Label15
            '
            Me.Label15.Location = New System.Drawing.Point(120, 216)
            Me.Label15.Name = "Label15"
            Me.Label15.Size = New System.Drawing.Size(152, 16)
            Me.Label15.TabIndex = 11
            Me.Label15.Text = "&Daily Calendar Resolution:"
            '
            'NumColumnsBox
            '
            Me.NumColumnsBox.EditValue = 1
            Me.NumColumnsBox.Location = New System.Drawing.Point(296, 184)
            Me.NumColumnsBox.Name = "NumColumnsBox"
            '
            'NumColumnsBox.Properties
            '
            Me.NumColumnsBox.Properties.Buttons.AddRange(New DevExpress.XtraEditors.Controls.EditorButton() {New DevExpress.XtraEditors.Controls.EditorButton})
            Me.NumColumnsBox.Properties.IsFloatValue = False
            Me.NumColumnsBox.Properties.MaxValue = New Decimal(New Integer() {25, 0, 0, 0})
            Me.NumColumnsBox.Properties.MinValue = New Decimal(New Integer() {1, 0, 0, 0})
            Me.NumColumnsBox.Properties.UseCtrlIncrement = False
            Me.NumColumnsBox.Size = New System.Drawing.Size(48, 20)
            Me.NumColumnsBox.TabIndex = 10
            '
            'lblNumColumns
            '
            Me.lblNumColumns.Location = New System.Drawing.Point(120, 186)
            Me.lblNumColumns.Name = "lblNumColumns"
            Me.lblNumColumns.Size = New System.Drawing.Size(176, 16)
            Me.lblNumColumns.TabIndex = 9
            Me.lblNumColumns.Text = "&Number of Employee Columns:"
            '
            'GroupBox7
            '
            Me.GroupBox7.Anchor = CType(((System.Windows.Forms.AnchorStyles.Top Or System.Windows.Forms.AnchorStyles.Left) _
                        Or System.Windows.Forms.AnchorStyles.Right), System.Windows.Forms.AnchorStyles)
            Me.GroupBox7.Location = New System.Drawing.Point(112, 168)
            Me.GroupBox7.Name = "GroupBox7"
            Me.GroupBox7.Size = New System.Drawing.Size(302, 3)
            Me.GroupBox7.TabIndex = 8
            Me.GroupBox7.TabStop = False
            '
            'Label10
            '
            Me.Label10.Location = New System.Drawing.Point(8, 160)
            Me.Label10.Name = "Label10"
            Me.Label10.TabIndex = 7
            Me.Label10.Text = "Calendars"
            '
            'GroupBox6
            '
            Me.GroupBox6.Anchor = CType(((System.Windows.Forms.AnchorStyles.Top Or System.Windows.Forms.AnchorStyles.Left) _
                        Or System.Windows.Forms.AnchorStyles.Right), System.Windows.Forms.AnchorStyles)
            Me.GroupBox6.Location = New System.Drawing.Point(112, 104)
            Me.GroupBox6.Name = "GroupBox6"
            Me.GroupBox6.Size = New System.Drawing.Size(302, 3)
            Me.GroupBox6.TabIndex = 5
            Me.GroupBox6.TabStop = False
            '
            'Label9
            '
            Me.Label9.Location = New System.Drawing.Point(8, 96)
            Me.Label9.Name = "Label9"
            Me.Label9.TabIndex = 4
            Me.Label9.Text = "Touch Screen"
            '
            'LeftButton
            '
            Me.LeftButton.Location = New System.Drawing.Point(120, 56)
            Me.LeftButton.Name = "LeftButton"
            '
            'LeftButton.Properties
            '
            Me.LeftButton.Properties.Caption = "Show on the &Left side"
            Me.LeftButton.Properties.CheckStyle = DevExpress.XtraEditors.Controls.CheckStyles.Radio
            Me.LeftButton.Properties.RadioGroupIndex = 1
            Me.LeftButton.Size = New System.Drawing.Size(144, 19)
            Me.LeftButton.TabIndex = 3
            Me.LeftButton.TabStop = False
            '
            'RightButton
            '
            Me.RightButton.EditValue = True
            Me.RightButton.Location = New System.Drawing.Point(120, 32)
            Me.RightButton.Name = "RightButton"
            '
            'RightButton.Properties
            '
            Me.RightButton.Properties.Caption = "Show on the &Right side"
            Me.RightButton.Properties.CheckStyle = DevExpress.XtraEditors.Controls.CheckStyles.Radio
            Me.RightButton.Properties.RadioGroupIndex = 1
            Me.RightButton.Size = New System.Drawing.Size(152, 19)
            Me.RightButton.TabIndex = 2
            '
            'GroupBox5
            '
            Me.GroupBox5.Anchor = CType(((System.Windows.Forms.AnchorStyles.Top Or System.Windows.Forms.AnchorStyles.Left) _
                        Or System.Windows.Forms.AnchorStyles.Right), System.Windows.Forms.AnchorStyles)
            Me.GroupBox5.Location = New System.Drawing.Point(112, 22)
            Me.GroupBox5.Name = "GroupBox5"
            Me.GroupBox5.Size = New System.Drawing.Size(302, 3)
            Me.GroupBox5.TabIndex = 1
            Me.GroupBox5.TabStop = False
            '
            'Label8
            '
            Me.Label8.Location = New System.Drawing.Point(8, 16)
            Me.Label8.Name = "Label8"
            Me.Label8.TabIndex = 0
            Me.Label8.Text = "Auxiliary Panel"
            '
            'LargeIconsCheckBox
            '
            Me.LargeIconsCheckBox.Location = New System.Drawing.Point(120, 120)
            Me.LargeIconsCheckBox.Name = "LargeIconsCheckBox"
            '
            'LargeIconsCheckBox.Properties
            '
            Me.LargeIconsCheckBox.Properties.Caption = "Show L&arge Icons"
            Me.LargeIconsCheckBox.Size = New System.Drawing.Size(128, 19)
            Me.LargeIconsCheckBox.TabIndex = 6
            '
            'OfficeHoursTabPage
            '
            Me.OfficeHoursTabPage.Controls.Add(Me.DailyCalendar1)
            Me.OfficeHoursTabPage.Controls.Add(Me.btnRemoveWorkTime)
            Me.OfficeHoursTabPage.Controls.Add(Me.btnSetWorkTime)
            Me.OfficeHoursTabPage.Controls.Add(Me.btnSetHolyday)
            Me.OfficeHoursTabPage.Location = New System.Drawing.Point(4, 22)
            Me.OfficeHoursTabPage.Name = "OfficeHoursTabPage"
            Me.OfficeHoursTabPage.Size = New System.Drawing.Size(432, 336)
            Me.OfficeHoursTabPage.TabIndex = 2
            Me.OfficeHoursTabPage.Text = "Opening Times"
            '
            'DailyCalendar1
            '
            Me.DailyCalendar1.AllDayVisible = False
            Me.DailyCalendar1.Anchor = CType((((System.Windows.Forms.AnchorStyles.Top Or System.Windows.Forms.AnchorStyles.Bottom) _
                        Or System.Windows.Forms.AnchorStyles.Left) _
                        Or System.Windows.Forms.AnchorStyles.Right), System.Windows.Forms.AnchorStyles)
            Me.DailyCalendar1.Cursor = System.Windows.Forms.Cursors.Default
            Me.DailyCalendar1.DateLabelFormat = "{0:ddd}"
            Me.DailyCalendar1.DayLineColor = System.Drawing.Color.FromArgb(CType(215, Byte), CType(177, Byte), CType(0, Byte))
            Me.DailyCalendar1.ExtraBreakHourColor = System.Drawing.Color.Fuchsia
            Me.DailyCalendar1.FirstDate = New Date(2006, 8, 7, 0, 0, 0, 0)
            Me.DailyCalendar1.FirstHour = System.TimeSpan.Parse("06:00:00")
            Me.DailyCalendar1.Font = New System.Drawing.Font("Tahoma", 8.25!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(204, Byte))
            Me.DailyCalendar1.FreeDay = ComponentGo.Calendars.FreeDays.None
            Me.DailyCalendar1.FreeHourColor = System.Drawing.Color.FromArgb(CType(255, Byte), CType(238, Byte), CType(158, Byte))
            Me.DailyCalendar1.Location = New System.Drawing.Point(0, 0)
            Me.DailyCalendar1.Name = "DailyCalendar1"
            Me.DailyCalendar1.ScrollBars = System.Windows.Forms.ScrollBars.Vertical
            Me.DailyCalendar1.Size = New System.Drawing.Size(430, 302)
            Me.DailyCalendar1.TabIndex = 0
            Me.DailyCalendar1.TodayMarkerVisible = False
            Me.DailyCalendar1.VisibleColumns = 7
            Me.DailyCalendar1.WorkHourBegin = System.TimeSpan.Parse("00:00:00")
            Me.DailyCalendar1.WorkHourEnd = System.TimeSpan.Parse("00:00:00")
            '
            'btnRemoveWorkTime
            '
            Me.btnRemoveWorkTime.Anchor = CType((System.Windows.Forms.AnchorStyles.Bottom Or System.Windows.Forms.AnchorStyles.Right), System.Windows.Forms.AnchorStyles)
            Me.btnRemoveWorkTime.Location = New System.Drawing.Point(288, 308)
            Me.btnRemoveWorkTime.Name = "btnRemoveWorkTime"
            Me.btnRemoveWorkTime.Size = New System.Drawing.Size(136, 23)
            Me.btnRemoveWorkTime.TabIndex = 3
            Me.btnRemoveWorkTime.Text = "&Remove Working Time"
            '
            'btnSetWorkTime
            '
            Me.btnSetWorkTime.Anchor = CType((System.Windows.Forms.AnchorStyles.Bottom Or System.Windows.Forms.AnchorStyles.Right), System.Windows.Forms.AnchorStyles)
            Me.btnSetWorkTime.Location = New System.Drawing.Point(144, 308)
            Me.btnSetWorkTime.Name = "btnSetWorkTime"
            Me.btnSetWorkTime.Size = New System.Drawing.Size(136, 23)
            Me.btnSetWorkTime.TabIndex = 2
            Me.btnSetWorkTime.Text = "&Add Working Time"
            '
            'btnSetHolyday
            '
            Me.btnSetHolyday.Anchor = CType((System.Windows.Forms.AnchorStyles.Bottom Or System.Windows.Forms.AnchorStyles.Right), System.Windows.Forms.AnchorStyles)
            Me.btnSetHolyday.Location = New System.Drawing.Point(0, 308)
            Me.btnSetHolyday.Name = "btnSetHolyday"
            Me.btnSetHolyday.Size = New System.Drawing.Size(136, 23)
            Me.btnSetHolyday.TabIndex = 1
            Me.btnSetHolyday.Text = "&Set As Holiday"
            '
            'MasterLevelTabPage
            '
            Me.MasterLevelTabPage.Controls.Add(Me.MasterLevelGridControl)
            Me.MasterLevelTabPage.Controls.Add(Me.RenameButton)
            Me.MasterLevelTabPage.Controls.Add(Me.AddButton)
            Me.MasterLevelTabPage.Controls.Add(Me.DeleteButton)
            Me.MasterLevelTabPage.Location = New System.Drawing.Point(4, 22)
            Me.MasterLevelTabPage.Name = "MasterLevelTabPage"
            Me.MasterLevelTabPage.Size = New System.Drawing.Size(432, 336)
            Me.MasterLevelTabPage.TabIndex = 1
            Me.MasterLevelTabPage.Text = "Master Level"
            '
            'MasterLevelGridControl
            '
            Me.MasterLevelGridControl.Anchor = CType((((System.Windows.Forms.AnchorStyles.Top Or System.Windows.Forms.AnchorStyles.Bottom) _
                        Or System.Windows.Forms.AnchorStyles.Left) _
                        Or System.Windows.Forms.AnchorStyles.Right), System.Windows.Forms.AnchorStyles)
            '
            'MasterLevelGridControl.EmbeddedNavigator
            '
            Me.MasterLevelGridControl.EmbeddedNavigator.Name = ""
            Me.MasterLevelGridControl.Location = New System.Drawing.Point(0, 0)
            Me.MasterLevelGridControl.MainView = Me.MasterLevelGridView
            Me.MasterLevelGridControl.Name = "MasterLevelGridControl"
            Me.MasterLevelGridControl.RepositoryItems.AddRange(New DevExpress.XtraEditors.Repository.RepositoryItem() {Me.IconRI})
            Me.MasterLevelGridControl.Size = New System.Drawing.Size(436, 298)
            Me.MasterLevelGridControl.TabIndex = 0
            Me.MasterLevelGridControl.Text = "GridControl1"
            '
            'MasterLevelGridView
            '
            Me.MasterLevelGridView.Columns.AddRange(New DevExpress.XtraGrid.Columns.GridColumn() {Me.GridColumnIcon, Me.GridColumnName})
            Me.MasterLevelGridView.GridControl = Me.MasterLevelGridControl
            Me.MasterLevelGridView.Name = "MasterLevelGridView"
            Me.MasterLevelGridView.OptionsBehavior.AutoSelectAllInEditor = False
            Me.MasterLevelGridView.OptionsBehavior.Editable = False
            Me.MasterLevelGridView.OptionsCustomization.AllowFilter = False
            Me.MasterLevelGridView.OptionsCustomization.AllowGroup = False
            Me.MasterLevelGridView.OptionsCustomization.AllowSort = False
            Me.MasterLevelGridView.OptionsDetail.EnableMasterViewMode = False
            Me.MasterLevelGridView.OptionsSelection.InvertSelection = True
            Me.MasterLevelGridView.OptionsView.ShowColumnHeaders = False
            Me.MasterLevelGridView.OptionsView.ShowGroupPanel = False
            Me.MasterLevelGridView.OptionsView.ShowIndicator = False
            Me.MasterLevelGridView.OptionsView.ShowVertLines = False
            '
            'GridColumnIcon
            '
            Me.GridColumnIcon.ColumnEdit = Me.IconRI
            Me.GridColumnIcon.Name = "GridColumnIcon"
            Me.GridColumnIcon.Options = CType(((DevExpress.XtraGrid.Columns.ColumnOptions.ReadOnly Or DevExpress.XtraGrid.Columns.ColumnOptions.FixedWidth) _
                        Or DevExpress.XtraGrid.Columns.ColumnOptions.NonEditable), DevExpress.XtraGrid.Columns.ColumnOptions)
            Me.GridColumnIcon.VisibleIndex = 0
            Me.GridColumnIcon.Width = 20
            '
            'IconRI
            '
            Me.IconRI.AutoHeight = False
            Me.IconRI.Buttons.AddRange(New DevExpress.XtraEditors.Controls.EditorButton() {New DevExpress.XtraEditors.Controls.EditorButton(DevExpress.XtraEditors.Controls.ButtonPredefines.Combo)})
            Me.IconRI.Items.AddRange(New Object() {New DevExpress.XtraEditors.Controls.ImageComboBoxItem("", Nothing, 6)})
            Me.IconRI.Name = "IconRI"
            '
            'GridColumnName
            '
            Me.GridColumnName.Caption = "Name"
            Me.GridColumnName.FieldName = "LevelName"
            Me.GridColumnName.Name = "GridColumnName"
            Me.GridColumnName.Options = CType(((DevExpress.XtraGrid.Columns.ColumnOptions.ReadOnly Or DevExpress.XtraGrid.Columns.ColumnOptions.CanFocused) _
                        Or DevExpress.XtraGrid.Columns.ColumnOptions.NonEditable), DevExpress.XtraGrid.Columns.ColumnOptions)
            Me.GridColumnName.VisibleIndex = 1
            Me.GridColumnName.Width = 238
            '
            'RenameButton
            '
            Me.RenameButton.Anchor = CType((System.Windows.Forms.AnchorStyles.Bottom Or System.Windows.Forms.AnchorStyles.Right), System.Windows.Forms.AnchorStyles)
            Me.RenameButton.Location = New System.Drawing.Point(141, 306)
            Me.RenameButton.Name = "RenameButton"
            Me.RenameButton.TabIndex = 1
            Me.RenameButton.Text = "&Rename"
            '
            'AddButton
            '
            Me.AddButton.Anchor = CType((System.Windows.Forms.AnchorStyles.Bottom Or System.Windows.Forms.AnchorStyles.Right), System.Windows.Forms.AnchorStyles)
            Me.AddButton.Location = New System.Drawing.Point(269, 306)
            Me.AddButton.Name = "AddButton"
            Me.AddButton.TabIndex = 2
            Me.AddButton.Text = "&Add"
            '
            'DeleteButton
            '
            Me.DeleteButton.Anchor = CType((System.Windows.Forms.AnchorStyles.Bottom Or System.Windows.Forms.AnchorStyles.Right), System.Windows.Forms.AnchorStyles)
            Me.DeleteButton.Location = New System.Drawing.Point(349, 306)
            Me.DeleteButton.Name = "DeleteButton"
            Me.DeleteButton.TabIndex = 3
            Me.DeleteButton.Text = "&Delete"
            '
            'OthersTab
            '
            Me.OthersTab.Controls.Add(Me.Label7)
            Me.OthersTab.Controls.Add(Me.Label6)
            Me.OthersTab.Controls.Add(Me.BusyTimeTextColorEdit)
            Me.OthersTab.Controls.Add(Me.LabelBusyTime)
            Me.OthersTab.Controls.Add(Me.BusyTimeColorEdit)
            Me.OthersTab.Controls.Add(Me.SelectedAppointmentTextColorEdit)
            Me.OthersTab.Controls.Add(Me.PaidAppointmentTextColorEdit)
            Me.OthersTab.Controls.Add(Me.OpenAppointmentTextColorEdit)
            Me.OthersTab.Controls.Add(Me.DefaultAppointmentTextColorEdit)
            Me.OthersTab.Controls.Add(Me.LabelPaidAppointment)
            Me.OthersTab.Controls.Add(Me.PaidAppointmentColorEdit)
            Me.OthersTab.Controls.Add(Me.LabelOpenAppointment)
            Me.OthersTab.Controls.Add(Me.OpenAppointmentColorEdit)
            Me.OthersTab.Controls.Add(Me.LabelDefaultColor)
            Me.OthersTab.Controls.Add(Me.DefaultAppointmentColorEdit)
            Me.OthersTab.Controls.Add(Me.LabelSelectedAppointment)
            Me.OthersTab.Controls.Add(Me.SelectedAppointmentColorEdit)
            Me.OthersTab.Controls.Add(Me.GroupBox2)
            Me.OthersTab.Controls.Add(Me.Label3)
            Me.OthersTab.Controls.Add(Me.PrintCheck)
            Me.OthersTab.Controls.Add(Me.OpenTillCheck)
            Me.OthersTab.Controls.Add(Me.GroupBox1)
            Me.OthersTab.Controls.Add(Me.Label2)
            Me.OthersTab.Controls.Add(Me.CriticalStockColor)
            Me.OthersTab.Controls.Add(Me.IndicateCriticalCheck)
            Me.OthersTab.Controls.Add(Me.StrongControlCheck)
            Me.OthersTab.Controls.Add(Me.Belevel2)
            Me.OthersTab.Controls.Add(Me.Label1)
            Me.OthersTab.Location = New System.Drawing.Point(4, 22)
            Me.OthersTab.Name = "OthersTab"
            Me.OthersTab.Size = New System.Drawing.Size(432, 336)
            Me.OthersTab.TabIndex = 5
            Me.OthersTab.Text = "Others"
            '
            'Label7
            '
            Me.Label7.Location = New System.Drawing.Point(301, 104)
            Me.Label7.Name = "Label7"
            Me.Label7.Size = New System.Drawing.Size(112, 16)
            Me.Label7.TabIndex = 34
            Me.Label7.Text = "Text"
            Me.Label7.TextAlign = System.Drawing.ContentAlignment.MiddleCenter
            '
            'Label6
            '
            Me.Label6.Location = New System.Drawing.Point(176, 104)
            Me.Label6.Name = "Label6"
            Me.Label6.Size = New System.Drawing.Size(112, 16)
            Me.Label6.TabIndex = 33
            Me.Label6.Text = "Background"
            Me.Label6.TextAlign = System.Drawing.ContentAlignment.MiddleCenter
            '
            'BusyTimeTextColorEdit
            '
            Me.BusyTimeTextColorEdit.EditValue = System.Drawing.Color.Empty
            Me.BusyTimeTextColorEdit.Location = New System.Drawing.Point(301, 216)
            Me.BusyTimeTextColorEdit.Name = "BusyTimeTextColorEdit"
            '
            'BusyTimeTextColorEdit.Properties
            '
            Me.BusyTimeTextColorEdit.Properties.Buttons.AddRange(New DevExpress.XtraEditors.Controls.EditorButton() {New DevExpress.XtraEditors.Controls.EditorButton(DevExpress.XtraEditors.Controls.ButtonPredefines.Combo)})
            Me.BusyTimeTextColorEdit.Size = New System.Drawing.Size(115, 20)
            Me.BusyTimeTextColorEdit.TabIndex = 32
            '
            'LabelBusyTime
            '
            Me.LabelBusyTime.Location = New System.Drawing.Point(112, 216)
            Me.LabelBusyTime.Name = "LabelBusyTime"
            Me.LabelBusyTime.Size = New System.Drawing.Size(64, 16)
            Me.LabelBusyTime.TabIndex = 30
            Me.LabelBusyTime.Text = "Busy time:"
            Me.LabelBusyTime.TextAlign = System.Drawing.ContentAlignment.MiddleLeft
            '
            'BusyTimeColorEdit
            '
            Me.BusyTimeColorEdit.EditValue = System.Drawing.Color.Empty
            Me.BusyTimeColorEdit.Location = New System.Drawing.Point(176, 216)
            Me.BusyTimeColorEdit.Name = "BusyTimeColorEdit"
            '
            'BusyTimeColorEdit.Properties
            '
            Me.BusyTimeColorEdit.Properties.Buttons.AddRange(New DevExpress.XtraEditors.Controls.EditorButton() {New DevExpress.XtraEditors.Controls.EditorButton(DevExpress.XtraEditors.Controls.ButtonPredefines.Combo)})
            Me.BusyTimeColorEdit.Size = New System.Drawing.Size(115, 20)
            Me.BusyTimeColorEdit.TabIndex = 31
            '
            'SelectedAppointmentTextColorEdit
            '
            Me.SelectedAppointmentTextColorEdit.EditValue = System.Drawing.Color.Empty
            Me.SelectedAppointmentTextColorEdit.Location = New System.Drawing.Point(301, 120)
            Me.SelectedAppointmentTextColorEdit.Name = "SelectedAppointmentTextColorEdit"
            '
            'SelectedAppointmentTextColorEdit.Properties
            '
            Me.SelectedAppointmentTextColorEdit.Properties.Buttons.AddRange(New DevExpress.XtraEditors.Controls.EditorButton() {New DevExpress.XtraEditors.Controls.EditorButton(DevExpress.XtraEditors.Controls.ButtonPredefines.Combo)})
            Me.SelectedAppointmentTextColorEdit.Size = New System.Drawing.Size(115, 20)
            Me.SelectedAppointmentTextColorEdit.TabIndex = 29
            '
            'PaidAppointmentTextColorEdit
            '
            Me.PaidAppointmentTextColorEdit.EditValue = System.Drawing.Color.Empty
            Me.PaidAppointmentTextColorEdit.Location = New System.Drawing.Point(301, 192)
            Me.PaidAppointmentTextColorEdit.Name = "PaidAppointmentTextColorEdit"
            '
            'PaidAppointmentTextColorEdit.Properties
            '
            Me.PaidAppointmentTextColorEdit.Properties.Buttons.AddRange(New DevExpress.XtraEditors.Controls.EditorButton() {New DevExpress.XtraEditors.Controls.EditorButton(DevExpress.XtraEditors.Controls.ButtonPredefines.Combo)})
            Me.PaidAppointmentTextColorEdit.Size = New System.Drawing.Size(115, 20)
            Me.PaidAppointmentTextColorEdit.TabIndex = 17
            '
            'OpenAppointmentTextColorEdit
            '
            Me.OpenAppointmentTextColorEdit.EditValue = System.Drawing.Color.Empty
            Me.OpenAppointmentTextColorEdit.Location = New System.Drawing.Point(301, 168)
            Me.OpenAppointmentTextColorEdit.Name = "OpenAppointmentTextColorEdit"
            '
            'OpenAppointmentTextColorEdit.Properties
            '
            Me.OpenAppointmentTextColorEdit.Properties.Buttons.AddRange(New DevExpress.XtraEditors.Controls.EditorButton() {New DevExpress.XtraEditors.Controls.EditorButton(DevExpress.XtraEditors.Controls.ButtonPredefines.Combo)})
            Me.OpenAppointmentTextColorEdit.Size = New System.Drawing.Size(115, 20)
            Me.OpenAppointmentTextColorEdit.TabIndex = 14
            '
            'DefaultAppointmentTextColorEdit
            '
            Me.DefaultAppointmentTextColorEdit.EditValue = System.Drawing.Color.Empty
            Me.DefaultAppointmentTextColorEdit.Location = New System.Drawing.Point(301, 144)
            Me.DefaultAppointmentTextColorEdit.Name = "DefaultAppointmentTextColorEdit"
            '
            'DefaultAppointmentTextColorEdit.Properties
            '
            Me.DefaultAppointmentTextColorEdit.Properties.Buttons.AddRange(New DevExpress.XtraEditors.Controls.EditorButton() {New DevExpress.XtraEditors.Controls.EditorButton(DevExpress.XtraEditors.Controls.ButtonPredefines.Combo)})
            Me.DefaultAppointmentTextColorEdit.Size = New System.Drawing.Size(115, 20)
            Me.DefaultAppointmentTextColorEdit.TabIndex = 11
            '
            'LabelPaidAppointment
            '
            Me.LabelPaidAppointment.Location = New System.Drawing.Point(112, 192)
            Me.LabelPaidAppointment.Name = "LabelPaidAppointment"
            Me.LabelPaidAppointment.Size = New System.Drawing.Size(56, 16)
            Me.LabelPaidAppointment.TabIndex = 15
            Me.LabelPaidAppointment.Text = "Paid:"
            Me.LabelPaidAppointment.TextAlign = System.Drawing.ContentAlignment.MiddleLeft
            '
            'PaidAppointmentColorEdit
            '
            Me.PaidAppointmentColorEdit.EditValue = System.Drawing.Color.Empty
            Me.PaidAppointmentColorEdit.Location = New System.Drawing.Point(176, 192)
            Me.PaidAppointmentColorEdit.Name = "PaidAppointmentColorEdit"
            '
            'PaidAppointmentColorEdit.Properties
            '
            Me.PaidAppointmentColorEdit.Properties.Buttons.AddRange(New DevExpress.XtraEditors.Controls.EditorButton() {New DevExpress.XtraEditors.Controls.EditorButton(DevExpress.XtraEditors.Controls.ButtonPredefines.Combo)})
            Me.PaidAppointmentColorEdit.Size = New System.Drawing.Size(115, 20)
            Me.PaidAppointmentColorEdit.TabIndex = 16
            '
            'LabelOpenAppointment
            '
            Me.LabelOpenAppointment.Location = New System.Drawing.Point(112, 168)
            Me.LabelOpenAppointment.Name = "LabelOpenAppointment"
            Me.LabelOpenAppointment.Size = New System.Drawing.Size(56, 16)
            Me.LabelOpenAppointment.TabIndex = 12
            Me.LabelOpenAppointment.Text = "&In salon:"
            Me.LabelOpenAppointment.TextAlign = System.Drawing.ContentAlignment.MiddleLeft
            '
            'OpenAppointmentColorEdit
            '
            Me.OpenAppointmentColorEdit.EditValue = System.Drawing.Color.Empty
            Me.OpenAppointmentColorEdit.Location = New System.Drawing.Point(176, 168)
            Me.OpenAppointmentColorEdit.Name = "OpenAppointmentColorEdit"
            '
            'OpenAppointmentColorEdit.Properties
            '
            Me.OpenAppointmentColorEdit.Properties.Buttons.AddRange(New DevExpress.XtraEditors.Controls.EditorButton() {New DevExpress.XtraEditors.Controls.EditorButton(DevExpress.XtraEditors.Controls.ButtonPredefines.Combo)})
            Me.OpenAppointmentColorEdit.Size = New System.Drawing.Size(115, 20)
            Me.OpenAppointmentColorEdit.TabIndex = 13
            '
            'LabelDefaultColor
            '
            Me.LabelDefaultColor.Location = New System.Drawing.Point(112, 144)
            Me.LabelDefaultColor.Name = "LabelDefaultColor"
            Me.LabelDefaultColor.Size = New System.Drawing.Size(56, 16)
            Me.LabelDefaultColor.TabIndex = 9
            Me.LabelDefaultColor.Text = "De&fault:"
            Me.LabelDefaultColor.TextAlign = System.Drawing.ContentAlignment.MiddleLeft
            '
            'DefaultAppointmentColorEdit
            '
            Me.DefaultAppointmentColorEdit.EditValue = System.Drawing.Color.Empty
            Me.DefaultAppointmentColorEdit.Location = New System.Drawing.Point(176, 144)
            Me.DefaultAppointmentColorEdit.Name = "DefaultAppointmentColorEdit"
            '
            'DefaultAppointmentColorEdit.Properties
            '
            Me.DefaultAppointmentColorEdit.Properties.Buttons.AddRange(New DevExpress.XtraEditors.Controls.EditorButton() {New DevExpress.XtraEditors.Controls.EditorButton(DevExpress.XtraEditors.Controls.ButtonPredefines.Combo)})
            Me.DefaultAppointmentColorEdit.Size = New System.Drawing.Size(115, 20)
            Me.DefaultAppointmentColorEdit.TabIndex = 10
            '
            'LabelSelectedAppointment
            '
            Me.LabelSelectedAppointment.Location = New System.Drawing.Point(112, 120)
            Me.LabelSelectedAppointment.Name = "LabelSelectedAppointment"
            Me.LabelSelectedAppointment.Size = New System.Drawing.Size(56, 16)
            Me.LabelSelectedAppointment.TabIndex = 6
            Me.LabelSelectedAppointment.Text = "Se&lected:"
            Me.LabelSelectedAppointment.TextAlign = System.Drawing.ContentAlignment.MiddleLeft
            '
            'SelectedAppointmentColorEdit
            '
            Me.SelectedAppointmentColorEdit.EditValue = System.Drawing.Color.Empty
            Me.SelectedAppointmentColorEdit.Location = New System.Drawing.Point(176, 120)
            Me.SelectedAppointmentColorEdit.Name = "SelectedAppointmentColorEdit"
            '
            'SelectedAppointmentColorEdit.Properties
            '
            Me.SelectedAppointmentColorEdit.Properties.Buttons.AddRange(New DevExpress.XtraEditors.Controls.EditorButton() {New DevExpress.XtraEditors.Controls.EditorButton(DevExpress.XtraEditors.Controls.ButtonPredefines.Combo)})
            Me.SelectedAppointmentColorEdit.Size = New System.Drawing.Size(115, 20)
            Me.SelectedAppointmentColorEdit.TabIndex = 7
            '
            'GroupBox2
            '
            Me.GroupBox2.Anchor = CType(((System.Windows.Forms.AnchorStyles.Top Or System.Windows.Forms.AnchorStyles.Left) _
                        Or System.Windows.Forms.AnchorStyles.Right), System.Windows.Forms.AnchorStyles)
            Me.GroupBox2.Location = New System.Drawing.Point(112, 96)
            Me.GroupBox2.Name = "GroupBox2"
            Me.GroupBox2.Size = New System.Drawing.Size(302, 3)
            Me.GroupBox2.TabIndex = 28
            Me.GroupBox2.TabStop = False
            '
            'Label3
            '
            Me.Label3.Location = New System.Drawing.Point(8, 90)
            Me.Label3.Name = "Label3"
            Me.Label3.Size = New System.Drawing.Size(104, 16)
            Me.Label3.TabIndex = 5
            Me.Label3.Text = "Appointment Colors"
            '
            'PrintCheck
            '
            Me.PrintCheck.Location = New System.Drawing.Point(120, 280)
            Me.PrintCheck.Name = "PrintCheck"
            Me.PrintCheck.Size = New System.Drawing.Size(120, 24)
            Me.PrintCheck.TabIndex = 10
            Me.PrintCheck.Text = "&Print Receipt"
            '
            'OpenTillCheck
            '
            Me.OpenTillCheck.Location = New System.Drawing.Point(120, 256)
            Me.OpenTillCheck.Name = "OpenTillCheck"
            Me.OpenTillCheck.Size = New System.Drawing.Size(152, 24)
            Me.OpenTillCheck.TabIndex = 19
            Me.OpenTillCheck.Text = "&Open Cash Drawer"
            '
            'GroupBox1
            '
            Me.GroupBox1.Anchor = CType(((System.Windows.Forms.AnchorStyles.Top Or System.Windows.Forms.AnchorStyles.Left) _
                        Or System.Windows.Forms.AnchorStyles.Right), System.Windows.Forms.AnchorStyles)
            Me.GroupBox1.Location = New System.Drawing.Point(112, 248)
            Me.GroupBox1.Name = "GroupBox1"
            Me.GroupBox1.Size = New System.Drawing.Size(302, 3)
            Me.GroupBox1.TabIndex = 26
            Me.GroupBox1.TabStop = False
            '
            'Label2
            '
            Me.Label2.Location = New System.Drawing.Point(8, 242)
            Me.Label2.Name = "Label2"
            Me.Label2.Size = New System.Drawing.Size(91, 16)
            Me.Label2.TabIndex = 18
            Me.Label2.Text = "Drawer && Printer"
            '
            'CriticalStockColor
            '
            Me.CriticalStockColor.EditValue = System.Drawing.Color.Empty
            Me.CriticalStockColor.Location = New System.Drawing.Point(312, 58)
            Me.CriticalStockColor.Name = "CriticalStockColor"
            '
            'CriticalStockColor.Properties
            '
            Me.CriticalStockColor.Properties.Buttons.AddRange(New DevExpress.XtraEditors.Controls.EditorButton() {New DevExpress.XtraEditors.Controls.EditorButton(DevExpress.XtraEditors.Controls.ButtonPredefines.Combo)})
            Me.CriticalStockColor.Size = New System.Drawing.Size(104, 20)
            Me.CriticalStockColor.TabIndex = 4
            '
            'IndicateCriticalCheck
            '
            Me.IndicateCriticalCheck.Location = New System.Drawing.Point(120, 56)
            Me.IndicateCriticalCheck.Name = "IndicateCriticalCheck"
            Me.IndicateCriticalCheck.Size = New System.Drawing.Size(192, 24)
            Me.IndicateCriticalCheck.TabIndex = 2
            Me.IndicateCriticalCheck.Text = "&Indicate critical product amount"
            '
            'StrongControlCheck
            '
            Me.StrongControlCheck.Location = New System.Drawing.Point(120, 32)
            Me.StrongControlCheck.Name = "StrongControlCheck"
            Me.StrongControlCheck.TabIndex = 1
            Me.StrongControlCheck.Text = "S&trong control"
            '
            'Belevel2
            '
            Me.Belevel2.Anchor = CType(((System.Windows.Forms.AnchorStyles.Top Or System.Windows.Forms.AnchorStyles.Left) _
                        Or System.Windows.Forms.AnchorStyles.Right), System.Windows.Forms.AnchorStyles)
            Me.Belevel2.Location = New System.Drawing.Point(112, 22)
            Me.Belevel2.Name = "Belevel2"
            Me.Belevel2.Size = New System.Drawing.Size(302, 3)
            Me.Belevel2.TabIndex = 21
            Me.Belevel2.TabStop = False
            '
            'Label1
            '
            Me.Label1.Location = New System.Drawing.Point(8, 16)
            Me.Label1.Name = "Label1"
            Me.Label1.Size = New System.Drawing.Size(72, 16)
            Me.Label1.TabIndex = 0
            Me.Label1.Text = "Stock Control"
            '
            'OkBtn
            '
            Me.OkBtn.Anchor = CType((System.Windows.Forms.AnchorStyles.Bottom Or System.Windows.Forms.AnchorStyles.Right), System.Windows.Forms.AnchorStyles)
            Me.OkBtn.Location = New System.Drawing.Point(277, 370)
            Me.OkBtn.Name = "OkBtn"
            Me.OkBtn.TabIndex = 1
            Me.OkBtn.Text = "&OK"
            '
            'CancelBtn
            '
            Me.CancelBtn.Anchor = CType((System.Windows.Forms.AnchorStyles.Bottom Or System.Windows.Forms.AnchorStyles.Right), System.Windows.Forms.AnchorStyles)
            Me.CancelBtn.DialogResult = System.Windows.Forms.DialogResult.Cancel
            Me.CancelBtn.Location = New System.Drawing.Point(357, 370)
            Me.CancelBtn.Name = "CancelBtn"
            Me.CancelBtn.TabIndex = 2
            Me.CancelBtn.Text = "&Cancel"
            '
            'OptionsDialog
            '
            Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
            Me.CancelButton = Me.CancelBtn
            Me.ClientSize = New System.Drawing.Size(440, 398)
            Me.Controls.Add(Me.OkBtn)
            Me.Controls.Add(Me.CancelBtn)
            Me.Controls.Add(Me.OptionsTabControl)
            Me.Icon = CType(resources.GetObject("$this.Icon"), System.Drawing.Icon)
            Me.MaximizeBox = False
            Me.MinimizeBox = False
            Me.MinimumSize = New System.Drawing.Size(448, 408)
            Me.Name = "OptionsDialog"
            Me.ShowInTaskbar = False
            Me.StartPosition = System.Windows.Forms.FormStartPosition.CenterParent
            Me.Text = "Options"
            Me.OptionsTabControl.ResumeLayout(False)
            Me.GeneralTabPage.ResumeLayout(False)
            CType(Me.SilenceAppointmentsDeletion.Properties, System.ComponentModel.ISupportInitialize).EndInit()
            CType(Me.SilenceAppointmentDeletion.Properties, System.ComponentModel.ISupportInitialize).EndInit()
            CType(Me.SilenceServicesDeletion.Properties, System.ComponentModel.ISupportInitialize).EndInit()
            CType(Me.SilenceProductsDeletion.Properties, System.ComponentModel.ISupportInitialize).EndInit()
            CType(Me.SilenceEmployeesDeletion.Properties, System.ComponentModel.ISupportInitialize).EndInit()
            CType(Me.SilenceClientsDeletion.Properties, System.ComponentModel.ISupportInitialize).EndInit()
            CType(Me.SilenceEmployeeDeletion.Properties, System.ComponentModel.ISupportInitialize).EndInit()
            CType(Me.SilenceProductDeletion.Properties, System.ComponentModel.ISupportInitialize).EndInit()
            CType(Me.SilenceServiceDeletion.Properties, System.ComponentModel.ISupportInitialize).EndInit()
            CType(Me.SilenceClientDeletion.Properties, System.ComponentModel.ISupportInitialize).EndInit()
            CType(Me.NameEdit.Properties, System.ComponentModel.ISupportInitialize).EndInit()
            Me.SecurityTab.ResumeLayout(False)
            CType(Me.TimeoutBox.Properties, System.ComponentModel.ISupportInitialize).EndInit()
            Me.LevelBox.ResumeLayout(False)
            Me.ViewPage.ResumeLayout(False)
            CType(Me.FitToPageCheckBox.Properties, System.ComponentModel.ISupportInitialize).EndInit()
            CType(Me.DayViewResolutionBox.Properties, System.ComponentModel.ISupportInitialize).EndInit()
            CType(Me.NumColumnsBox.Properties, System.ComponentModel.ISupportInitialize).EndInit()
            CType(Me.LeftButton.Properties, System.ComponentModel.ISupportInitialize).EndInit()
            CType(Me.RightButton.Properties, System.ComponentModel.ISupportInitialize).EndInit()
            CType(Me.LargeIconsCheckBox.Properties, System.ComponentModel.ISupportInitialize).EndInit()
            Me.OfficeHoursTabPage.ResumeLayout(False)
            Me.MasterLevelTabPage.ResumeLayout(False)
            CType(Me.MasterLevelGridControl, System.ComponentModel.ISupportInitialize).EndInit()
            CType(Me.MasterLevelGridView, System.ComponentModel.ISupportInitialize).EndInit()
            CType(Me.IconRI, System.ComponentModel.ISupportInitialize).EndInit()
            Me.OthersTab.ResumeLayout(False)
            CType(Me.BusyTimeTextColorEdit.Properties, System.ComponentModel.ISupportInitialize).EndInit()
            CType(Me.BusyTimeColorEdit.Properties, System.ComponentModel.ISupportInitialize).EndInit()
            CType(Me.SelectedAppointmentTextColorEdit.Properties, System.ComponentModel.ISupportInitialize).EndInit()
            CType(Me.PaidAppointmentTextColorEdit.Properties, System.ComponentModel.ISupportInitialize).EndInit()
            CType(Me.OpenAppointmentTextColorEdit.Properties, System.ComponentModel.ISupportInitialize).EndInit()
            CType(Me.DefaultAppointmentTextColorEdit.Properties, System.ComponentModel.ISupportInitialize).EndInit()
            CType(Me.PaidAppointmentColorEdit.Properties, System.ComponentModel.ISupportInitialize).EndInit()
            CType(Me.OpenAppointmentColorEdit.Properties, System.ComponentModel.ISupportInitialize).EndInit()
            CType(Me.DefaultAppointmentColorEdit.Properties, System.ComponentModel.ISupportInitialize).EndInit()
            CType(Me.SelectedAppointmentColorEdit.Properties, System.ComponentModel.ISupportInitialize).EndInit()
            CType(Me.CriticalStockColor.Properties, System.ComponentModel.ISupportInitialize).EndInit()
            Me.ResumeLayout(False)

        End Sub

#End Region

#Region " Private Fields "
        Private mName As String
        Private mHours As Integer
        Private mWeekBegin(7) As TimeSpan
        Private mWeekEnd(7) As TimeSpan
        Private mHolyday(7) As Boolean

        Private mCurrentBreak As New Panel
        Private mBreaks As ComponentGo.Calendars.BreakCollection

        Private SalonID As Long
#End Region

#Region " Schedule "
        Private mOfficeTimeChanged As Boolean = False
        Private mBreakManagers(6) As BreakManager

        Private Sub LoadScheduleTab()
            mOfficeTimeChanged = False

            For i As Integer = 0 To 6
                mBreakManagers(i) = New BreakManager
            Next

            For Each st As DataSetData.SalonTime In AppDataLayer.SalonTimes
                mBreakManagers(st.DayOfWeek).AddWorkTime(TimeSpan.FromMinutes(st.StartTime), TimeSpan.FromMinutes(st.FinishTime))
                mBreakManagers(st.DayOfWeek).Modified = False
            Next

            'Set the first week day as Sunday
            Dim day As DateTime = Today
            Dim wd As DayOfWeek = day.DayOfWeek

            day = day.Subtract(TimeSpan.FromDays(wd))

            DailyCalendar1.FirstDate = day
            DailyCalendar1.HoursResolution = AppConfig.DayViewResolution
        End Sub

        Private Sub SaveScheduleTab()
            If Not mOfficeTimeChanged Then Return

            For i As Integer = 0 To 6
                If mBreakManagers(i).Modified Then
                    UpdateDaySchedule(i, mBreakManagers(i))
                End If
            Next

            AppRaiseEvent(Me, New PhoenixEventArgs(Nothing, PhoenixEventCode.ScheduleChanged))
        End Sub


        Private Sub UpdateDaySchedule(ByVal DayOfWeek As Integer, ByVal man As BreakManager)
            'Clear old schedule
            Dim rows() As DataRow = AppDataLayer.SalonTimes.Select("DayOfWeek=" & DayOfWeek)
            For i As Integer = 0 To rows.Length - 1
                rows(i).Delete()
            Next

            'Create a new schedule
            Dim st As DataSetData.SalonTime
            If man.Breaks.Count = 0 Then
                st = AppDataLayer.SalonTimes.NewSalonTime
                st.DayOfWeek = DayOfWeek
                st.StartTime = 0
                st.FinishTime = 24 * 60
                AppDataLayer.SalonTimes.AddSalonTime(st)
            Else
                Dim t As Integer = man.Breaks.GetByIndex(0).EndBreak.TotalMinutes
                For i As Integer = 1 To man.Breaks.Count - 1
                    Dim b As ComponentGo.Calendars.Break = man.Breaks.GetByIndex(i)
                    st = AppDataLayer.SalonTimes.NewSalonTime
                    st.DayOfWeek = DayOfWeek
                    st.StartTime = t
                    st.FinishTime = b.BeginBreak.TotalMinutes
                    AppDataLayer.SalonTimes.AddSalonTime(st)

                    t = b.EndBreak.TotalMinutes
                Next
            End If

            Try
                AppDataLayer.UpdateSalonTimes(AppDataLayer.SalonTimes)
            Catch ex As Exception
                AppDataLayer.SalonTimes.RejectChanges()
                Throw
            End Try
        End Sub


        Private TimeSpanDay As TimeSpan = TimeSpan.FromHours(24)
        Private Sub ScheduleCalendar_GetDayInfo(ByVal sender As Object, ByVal args As ComponentGo.Calendars.GetDayInfoEventArgs) Handles DailyCalendar1.GetDayInfo
            args.WorkHourBegin = TimeSpan.Zero
            args.WorkHourEnd = TimeSpanDay

            args.Breaks.AddRange(mBreakManagers(args.Date.DayOfWeek).Breaks)
        End Sub


        Private Sub SetHolyday_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSetHolyday.Click
            mOfficeTimeChanged = True

            Dim sdb As DateTime = DailyCalendar1.SelectedDateBegin
            Dim sde As DateTime = DailyCalendar1.SelectedDateEnd
            For wd As Integer = sdb.DayOfWeek To sde.DayOfWeek
                mBreakManagers(wd).AddBreak(TimeSpan.Zero, TimeSpanDay)
            Next

            DailyCalendar1.Invalidate()
        End Sub

        Private Sub SetWorkTime_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSetWorkTime.Click
            mOfficeTimeChanged = True

            Dim sdb As DateTime = DailyCalendar1.SelectedDateBegin
            Dim sde As DateTime = DailyCalendar1.SelectedDateEnd

            If sdb.DayOfWeek = sde.DayOfWeek Then
                mBreakManagers(sdb.DayOfWeek).AddWorkTime(sdb.TimeOfDay, sde.TimeOfDay)
            Else
                mBreakManagers(sdb.DayOfWeek).AddWorkTime(sdb.TimeOfDay, TimeSpanDay)
                For wd As Integer = sdb.DayOfWeek + 1 To sde.DayOfWeek - 1
                    mBreakManagers(wd).AddWorkTime(TimeSpan.Zero, TimeSpanDay)
                Next
                mBreakManagers(sde.DayOfWeek).AddWorkTime(TimeSpan.Zero, sde.TimeOfDay)
            End If

            DailyCalendar1.Invalidate()
        End Sub

        Private Sub SetBreak_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnRemoveWorkTime.Click
            mOfficeTimeChanged = True

            Dim sdb As DateTime = DailyCalendar1.SelectedDateBegin
            Dim sde As DateTime = DailyCalendar1.SelectedDateEnd

            If sdb.DayOfWeek = sde.DayOfWeek Then
                mBreakManagers(sdb.DayOfWeek).AddBreak(sdb.TimeOfDay, sde.TimeOfDay)
            Else
                mBreakManagers(sdb.DayOfWeek).AddBreak(sdb.TimeOfDay, TimeSpanDay)
                For wd As Integer = sdb.DayOfWeek + 1 To sde.DayOfWeek - 1
                    mBreakManagers(wd).AddBreak(TimeSpan.Zero, TimeSpanDay)
                Next
                mBreakManagers(sde.DayOfWeek).AddBreak(TimeSpan.Zero, sde.TimeOfDay)
            End If

            DailyCalendar1.Invalidate()
        End Sub
#End Region

#Region " Event Handlers "
        Private Sub OkBtn_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles OkBtn.Click
            Dim logoff As Boolean = False


            'Security
            If AppConfig.UserModeEnabled = SimpleModeButton.Checked Then
                logoff = True
            ElseIf SimpleModeButton.Checked Then
                If AppConfig.DefaultSecurityLevel <> GetSelectedSecurityLevel() Then logoff = True
            End If
            AppConfig.UserModeEnabled = UserModeButton.Checked
            AppConfig.DefaultSecurityLevel = GetSelectedSecurityLevel()
            AppConfig.EnableAutoLogout = EnableAutoLogoutBox.Checked
            AppConfig.AutoLogoutTime = TimeoutBox.Value

            SaveGenerals()
            SaveViewTab()
            SaveScheduleTab()
            SaveOthersTab()

            Close()

            If logoff Then
                AppMessageBox(Res.NeedLogoffMessage, MsgBoxStyle.Exclamation)
            End If
        End Sub

        Private Sub OptionsDialog_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
            'Restrict access
            If Not Security.IsAdministrator Then
                OptionsTabControl.TabPages.Remove(MasterLevelTabPage)
                OptionsTabControl.TabPages.Remove(OfficeHoursTabPage)
                OptionsTabControl.TabPages.Remove(SecurityTab)
                OptionsTabControl.TabPages.Remove(OthersTab)
            End If

            If Not Security.IsManager Then
                NameEdit.Properties.ReadOnly = True
            End If


            'Tune icons
            IconRI.SmallImages = AppSharedComponents.ListImages
            GridColumnIcon.MinWidth = IconRI.SmallImages.ImageSize.Width + AppIconColumnPadding

            MasterLevelGridControl.DataSource = AppDataLayer.MasterLevels

            'Security
            SimpleModeButton.Checked = Not AppConfig.UserModeEnabled
            UserModeButton.Checked = AppConfig.UserModeEnabled
            Select Case AppConfig.DefaultSecurityLevel
                Case Security.SecurityRole.Administrator
                    AdministratorButton.Checked = True
                Case Security.SecurityRole.Manager
                    ManagerButton.Checked = True
                Case Security.SecurityRole.[Operator]
                    OperatorButton.Checked = True
            End Select
            EnableAutoLogoutBox.Checked = AppConfig.EnableAutoLogout
            TimeoutBox.Value = AppConfig.AutoLogoutTime


            LoadGenerals()
            LoadViewTab()
            LoadScheduleTab()
            LoadOthersTab()
        End Sub

        Private Sub CancelBtn_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CancelBtn.Click
            Close()
        End Sub

#End Region

#Region " Security "
        Private Function GetSelectedSecurityLevel() As Security.SecurityRole
            If AdministratorButton.Checked Then Return Security.SecurityRole.Administrator
            If ManagerButton.Checked Then Return Security.SecurityRole.Manager
            If OperatorButton.Checked Then Return Security.SecurityRole.[Operator]
        End Function

        Private Sub SimpleModeButton_CheckedChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles SimpleModeButton.CheckedChanged
            LevelBox.Enabled = SimpleModeButton.Checked
        End Sub

        Private Sub EnableAutoLogoutBox_CheckedChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles EnableAutoLogoutBox.CheckedChanged
            TimeoutBox.Properties.Enabled = EnableAutoLogoutBox.Checked
        End Sub

#End Region

#Region " Master Levels "
        Private Sub AddButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles AddButton.Click
            Dim dlg As New NewMasterLevelDialog
            If IsNotInvalidRowHandle(MasterLevelGridView.FocusedRowHandle) Then
                dlg.MasterLevel = CType(MasterLevelGridView.GetDataRow(MasterLevelGridView.FocusedRowHandle), DataSetData.MasterLevel)
            End If
            dlg.ShowDialog()
        End Sub


        Private Sub RenameButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles RenameButton.Click
            Dim rh As Integer = MasterLevelGridView.FocusedRowHandle
            If IsInvalidRowHandle(rh) Then Return

            Dim dlg As New RenameMasterLevelDialog

            dlg.MasterLevel = CType(MasterLevelGridView.GetDataRow(rh), DataSetData.MasterLevel)

            dlg.ShowDialog()
        End Sub


        Private Sub DeleteButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles DeleteButton.Click
            If IsInvalidRowHandle(MasterLevelGridView.FocusedRowHandle) Then Return

            AppDataLayer.DoInTransaction(AddressOf DeleteMasterLevel)
        End Sub

        Private Sub DeleteMasterLevel()
            Dim rh As Integer = MasterLevelGridView.FocusedRowHandle
            If IsInvalidRowHandle(rh) Then Return

            Dim ml As DataSetData.MasterLevel = CType(MasterLevelGridView.GetDataRow(rh), DataSetData.MasterLevel)
            MasterLevelHelper.RemoveMasterLevel(ml)
        End Sub
#End Region

#Region " Others "
        Private Sub IndicateCriticalCheck_CheckedChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles IndicateCriticalCheck.CheckedChanged
            CriticalStockColor.Enabled = IndicateCriticalCheck.Checked
        End Sub

        Private Sub LoadOthersTab()
            StrongControlCheck.Checked = AppConfig.StrongStockMode
            IndicateCriticalCheck.Checked = AppConfig.IndicateCriticalStock
            CriticalStockColor.Color = AppConfig.CriticalStockColor

            BusyTimeColorEdit.Color = AppConfig.BreakBackColor
            SelectedAppointmentColorEdit.Color = AppConfig.SelectedAppointmentBackColor
            DefaultAppointmentColorEdit.Color = AppConfig.ScheduleAppointmentBackColor
            OpenAppointmentColorEdit.Color = AppConfig.OpenAppointmentBackColor
            PaidAppointmentColorEdit.Color = AppConfig.PaidAppointmentBackColor
            BusyTimeTextColorEdit.Color = AppConfig.BreakForeColor
            SelectedAppointmentTextColorEdit.Color = AppConfig.SelectedAppointmentForeColor
            DefaultAppointmentTextColorEdit.Color = AppConfig.ScheduleAppointmentForeColor
            OpenAppointmentTextColorEdit.Color = AppConfig.OpenAppointmentForeColor
            PaidAppointmentTextColorEdit.Color = AppConfig.PaidAppointmentForeColor

            OpenTillCheck.Checked = AppConfig.OpenCashDrawer
            PrintCheck.Checked = AppConfig.PrintReceipt

            CriticalStockColor.Enabled = IndicateCriticalCheck.Checked
        End Sub

        Private Sub SaveOthersTab()
            AppConfig.StrongStockMode = StrongControlCheck.Checked
            AppConfig.IndicateCriticalStock = IndicateCriticalCheck.Checked
            AppConfig.CriticalStockColor = CriticalStockColor.Color
            AppConfig.OpenCashDrawer = OpenTillCheck.Checked
            AppConfig.PrintReceipt = PrintCheck.Checked

            AppConfig.BreakBackColor = BusyTimeColorEdit.Color
            AppConfig.SelectedAppointmentBackColor = SelectedAppointmentColorEdit.Color
            AppConfig.ScheduleAppointmentBackColor = DefaultAppointmentColorEdit.Color
            AppConfig.OpenAppointmentBackColor = OpenAppointmentColorEdit.Color
            AppConfig.PaidAppointmentBackColor = PaidAppointmentColorEdit.Color
            AppConfig.BreakForeColor = BusyTimeTextColorEdit.Color
            AppConfig.SelectedAppointmentForeColor = SelectedAppointmentTextColorEdit.Color
            AppConfig.ScheduleAppointmentForeColor = DefaultAppointmentTextColorEdit.Color
            AppConfig.OpenAppointmentForeColor = OpenAppointmentTextColorEdit.Color
            AppConfig.PaidAppointmentForeColor = PaidAppointmentTextColorEdit.Color
        End Sub
#End Region

#Region " Generals "
        Private Sub LoadGenerals()
            Me.NameEdit.Text = AppConfig.SalonName
            Me.SilenceAppointmentDeletion.Checked = Not AppConfig.SilenceAppointmentDeletion
            Me.SilenceClientDeletion.Checked = Not AppConfig.SilenceClientDeletion
            Me.SilenceEmployeeDeletion.Checked = Not AppConfig.SilenceEmployeeDeletion
            Me.SilenceProductDeletion.Checked = Not AppConfig.SilenceProductDeletion
            Me.SilenceServiceDeletion.Checked = Not AppConfig.SilenceServiceDeletion
            Me.SilenceAppointmentsDeletion.Checked = Not AppConfig.SilenceAppointmentsDeletion
            Me.SilenceClientsDeletion.Checked = Not AppConfig.SilenceClientsDeletion
            Me.SilenceEmployeesDeletion.Checked = Not AppConfig.SilenceEmployeesDeletion
            Me.SilenceProductsDeletion.Checked = Not AppConfig.SilenceProductsDeletion
            Me.SilenceServicesDeletion.Checked = Not AppConfig.SilenceServicesDeletion
        End Sub

        Private Sub SaveGenerals()
            AppConfig.SilenceEmployeeDeletion = Not Me.SilenceEmployeeDeletion.Checked
            AppConfig.SilenceProductDeletion = Not Me.SilenceProductDeletion.Checked
            AppConfig.SilenceServiceDeletion = Not Me.SilenceServiceDeletion.Checked
            AppConfig.SilenceClientDeletion = Not Me.SilenceClientDeletion.Checked
            AppConfig.SilenceAppointmentDeletion = Not Me.SilenceAppointmentDeletion.Checked
            AppConfig.SalonName = NameEdit.Text
            AppConfig.SilenceEmployeesDeletion = Not Me.SilenceEmployeesDeletion.Checked
            AppConfig.SilenceProductsDeletion = Not Me.SilenceProductsDeletion.Checked
            AppConfig.SilenceServicesDeletion = Not Me.SilenceServicesDeletion.Checked
            AppConfig.SilenceClientsDeletion = Not Me.SilenceClientsDeletion.Checked
            AppConfig.SilenceAppointmentsDeletion = Not Me.SilenceAppointmentsDeletion.Checked
        End Sub
#End Region

#Region " View "
        Private Sub LoadViewTab()
            Me.LargeIconsCheckBox.Checked = AppConfig.LargeIcons
            Me.LeftButton.Checked = AppConfig.TaskPaneLeft
            Me.RightButton.Checked = Not AppConfig.TaskPaneLeft
            Me.NumColumnsBox.Value = AppConfig.DayViewColumnNumber
            Me.FitToPageCheckBox.Checked = AppConfig.FitToPage

            Dim index As Integer = CInt(AppConfig.DayViewResolution) - 2
            If index < 0 Then index = 0
            Me.DayViewResolutionBox.SelectedIndex = index
        End Sub


        Private Sub SaveViewTab()
            AppConfig.LargeIcons = Me.LargeIconsCheckBox.Checked
            AppConfig.TaskPaneLeft = Me.LeftButton.Checked
            AppConfig.DayViewColumnNumber = Me.NumColumnsBox.Value
            AppConfig.DayViewResolution = 2 + Me.DayViewResolutionBox.SelectedIndex
            AppConfig.FitToPage = Me.FitToPageCheckBox.Checked
        End Sub
#End Region

    End Class

End Namespace

