Imports System.Reflection
Imports System.Resources

''' <summary>
''' The resource wrapper.
''' </summary>
Friend NotInheritable Class Res

    Private Shared Function GetString(ByVal name As String) As String
        Return ResourceManager.GetString(name)
    End Function

    ''' The resource strings wrappers
    Friend Shared ReadOnly Property ISS_SystemStoreNotSupported() As String
        Get
            Return GetString("ISS_SystemStoreNotSupported")
        End Get
    End Property

    Friend Shared ReadOnly Property APN_NameArgNull() As String
        Get
            Return GetString("APN_NameArgNull")
        End Get
    End Property

    Friend Shared ReadOnly Property APN_RootArgEmpty() As String
        Get
            Return GetString("APN_RootArgEmpty")
        End Get
    End Property

    Friend Shared ReadOnly Property APN_NonRootArgEmpty() As String
        Get
            Return GetString("APN_NonRootArgEmpty")
        End Get
    End Property

    Friend Shared ReadOnly Property APN_NodeRemoved() As String
        Get
            Return GetString("APN_NodeRemoved")
        End Get
    End Property

    Friend Shared ReadOnly Property APN_NodeCreate() As String
        Get
            Return GetString("APN_NodeCreate")
        End Get
    End Property

    Friend Shared ReadOnly Property APN_RemoveAllPreferences() As String
        Get
            Return GetString("APN_RemoveAllPreferences")
        End Get
    End Property

    Friend Shared ReadOnly Property APN_PathNameSlash() As String
        Get
            Return GetString("APN_PathNameSlash")
        End Get
    End Property


    Friend Shared ReadOnly Property APN_Synchonize() As String
        Get
            Return GetString("APN_Synchonize")
        End Get
    End Property

    Friend Shared ReadOnly Property APN_RootRemove() As String
        Get
            Return GetString("APN_RootRemove")
        End Get
    End Property

    Friend Shared ReadOnly Property APN_NodeRemove() As String
        Get
            Return GetString("APN_NodeRemove")
        End Get
    End Property

    Friend Shared ReadOnly Property APN_GetKeys() As String
        Get
            Return GetString("APN_GetKeys")
        End Get
    End Property


    Friend Shared ReadOnly Property APN_KeyRemove() As String
        Get
            Return GetString("APN_KeyRemove")
        End Get
    End Property


    Friend Shared ReadOnly Property APN_KeyNull() As String
        Get
            Return GetString("APN_KeyNull")
        End Get
    End Property

    Friend Shared ReadOnly Property APN_ValueNull() As String
        Get
            Return GetString("APN_ValueNull")
        End Get
    End Property

    Friend Shared ReadOnly Property ISPN_Init() As String
        Get
            Return GetString("ISPN_Init")
        End Get
    End Property

    Friend Shared ReadOnly Property ISPN_Create() As String
        Get
            Return GetString("ISPN_Create")
        End Get
    End Property

    ''' <summary>
    ''' The resource manager accessor.
    ''' </summary>
    ''' <remarks>The property is implemented with lazy-initialization logic.</remarks>
    ''' <value>The resource manager</value>
    Private Shared ReadOnly Property ResourceManager() As ResourceManager
        Get
            If mResourceManager Is Nothing Then
                mResourceManager = New ResourceManager("Phoenix.Preferences.Resources", [Assembly].GetCallingAssembly())
            End If
            Return mResourceManager
        End Get
    End Property


    Private Shared mResourceManager As ResourceManager = Nothing
End Class
