Namespace Store

    Public NotInheritable Class IsolatedStorageStore : Inherits BackingStore

        Private Shared ReadOnly mInstance As IsolatedStorageStore = New IsolatedStorageStore

        Private Sub New()
        End Sub

        Public Shared ReadOnly Property Instance() As IsolatedStorageStore
            Get
                Return mInstance
            End Get
        End Property


        Protected Friend Overrides Function GetUserRootNodeFromStorage() As IPreferencesNode
            Return IsolatedStoragePreferencesNode.UserRootNode
        End Function

        Protected Friend Overrides Function GetSystemRootNodeFromStorage() As IPreferencesNode
            '' Isolated storage doesn't support system-wide root
            Throw New NotSupportedException(Res.ISS_SystemStoreNotSupported)
        End Function
    End Class

End Namespace
