Option Strict On

Imports Excel = Microsoft.Office.Interop.Excel
'Imports Office = Microsoft.Office.Core
Imports System.Text.RegularExpressions
Imports System.Runtime.InteropServices

Public Class Spacers

    Private Const defaultSearchSymbol As Char = "&"c
    Private Const defaultSearchPattern As String = defaultSearchSymbol & defaultSearchSymbol

    Public Shared Function FindSpacers(ByVal rangeToSearch As Excel.Range, ByVal initData As DataSet) As IList
        Dim rngFound As Excel.Range
        Dim findList As ArrayList = New ArrayList

        Dim rngFoundFirst As Excel.Range

        rngFound = rangeToSearch.Find( _
            defaultSearchPattern, , _
            Excel.XlFindLookIn.xlFormulas, Excel.XlLookAt.xlPart, _
            Excel.XlSearchOrder.xlByRows, Excel.XlSearchDirection.xlNext, False)

        While Not rngFound Is Nothing
            If rngFoundFirst Is Nothing Then
                rngFoundFirst = rngFound
            ElseIf rngFound.Address = rngFoundFirst.Address Then
                Exit While
            End If
            Try
                Dim o As Object = rngFound.PivotField
            Catch ex As Exception
                Dim s As ITemplateSpacer = CreateTemplateSpacer(rngFound, initData)
                If (Not s Is Nothing) Then
                    findList.Add(s)
                End If
            End Try
            rngFound = rangeToSearch.FindNext(rngFound)
        End While

        Return findList
    End Function

    Private Shared Function CreateTemplateSpacer(ByRef location As Excel.Range, ByVal initData As DataSet) As ITemplateSpacer
        Dim table As ITemplateTable
        If (IsSpacer(location)) Then
            Dim name As String = location.Value.ToString.TrimStart(defaultSearchSymbol)
            Return New RowSpacer(name, initData, location, 0.33D)
        End If
        Return Nothing
    End Function

    Private Shared Function IsSpacer(ByVal location As Excel.Range) As Boolean
        Dim str As String = location.Value.ToString
        Dim match As match = Regex.Match(location.Value.ToString, "^\&\&\w+")
        If (match.Success) Then
            Return match.Value = str
        Else
            Return False
        End If
    End Function
End Class
